#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Thu May 28 08:30:56 2020

@author: lenaboysen

Read in data for maps (incl. stat significance testing)


"""


import os
import numpy as np
np.set_printoptions(threshold=100) # 'nan'
#import os.path
import sys as sys
import pickle

#import cdo
#cdo = cdo.Cdo()
#cdo.setCdo('/opt/local/bin/cdo')
import xarray as xr
#from matplotlib import gridspec
#from datetime import datetime, date, time, timedelta

#plot
import matplotlib.pyplot as plt
import matplotlib as mpl
import matplotlib.colors as colors
import seaborn as sns; sns.set(color_codes=True)
import cartopy.crs as ccrs

#import plotly.plotly as py
#import plotly.graph_objs as go
import pandas as pd



new_path = '/Users/lenaboysen/Google Drive/python/'
if new_path not in sys.path:
    sys.path.append(new_path)
    
#from mod_tTest import *
import mod_tTest as ttest
import zerodivcolormap as zcmap
 
## Constants
kg_C_per_kg_CO2 = 0.272918
kg_C_perMol = 0.012011
C_to_K = 273.15
MPa_to_mm = 1022.8

#%% FUNCTIONS

def whitelinefix(lons):
    return np.append(lons,360)

def make_ticklabels_invisible(fig):
    for i, ax in enumerate(fig.axes):
        ax.text(0.5, 0.5, "ax%d" % (i+1), va="center", ha="center")
        for tl in ax.get_xticklabels() + ax.get_yticklabels():
            tl.set_visible(False)
            
# Set colormap and centre the colorbar
class MidpointNormalize(colors.Normalize):
    """
    Normalize the colorbar so that diverging bars  work their way either side from a prescribed midpoint value
    e.g. im=ax1.imshow(arry, norm=MidpointNormalize(midpoint=0.,vmin0-100,vmax=100))
    """
    def __init__(self, vmin=None, vmax=None, midpoint=None, clip=False):
        self.midpoint = midpoint
        colors.Normalize.__init__(self,vmin,vmax,clip)
        
    def __call__(self, value,clip=None):
        x, y = [self.vmin, self.midpoint, self.vmax], [0, 0.5, 1]
        return np.ma.masked_array(np.interp(value, x, y), np.isnan(value))
                
       
def read_data(var,timstat,model,path,runs,lat=None,lon=None):
#    var = 'treeFrac'
#    timstat = 'year'
#    path = "/Users/lenaboysen/mistral/LUMIP/IPSL/"
#    length = 1
#    var = [var]
#    vv = 0;
#    runs = ['r1i1p1f1','r2i1p1f1','r3i1p1f1','r4i1p1f1',\
#                               'r5i1p1f1','r6i1p1f1','r7i1p1f1']

    if type(var) == str:
        length = 1
        var = [var]
    elif type(var) == list:
        length = np.shape(var)[0]
        
    ds_data = None
    for vv in range(0,length):       
        for rr in runs: 
            
            print 'read in exp = '+ model+ ' '+ rr + ' ' + ' '+ var[vv]
            ds_new = xr.open_dataset(path + rr +'/'\
                                     +var[vv]+'_'+model+'_'+timstat+'.nc',\
                                     cache=False, decode_times=False)
            ds_new.close()
    
#            print ds_new[var[vv]].shape # dsA.cveg.coords, dsA.cveg.dims, dsA.info
            ### Data must be in shape  lon, lat, time!!
            nt = np.shape(ds_new['time'])[0]
            if timstat == 'year':
                ff = 'y'
            else:
                ff = 'm'
            
#            if lat is None and (rr == runs[0] or rr == 'piControl'):
#                    lat = ds_new['lat'].values
#            if lon is None and (rr == runs[0] or rr == 'piControl'):
#                    lon = ds_new['lon'].values 
                    
            lat = def_mask_regions[model][model+'_deffrac_glob'].lat
#                lat = ds_new['lat'].values
            lon = def_mask_regions[model][model+'_deffrac_glob'].lon
#            lon = ds_new['lon'].values

            startyear = 1850
            time = pd.date_range(str(startyear)+'-01-01', periods=nt, freq=ff)
            ds_new2 = xr.Dataset({var[vv]:(('time', 'lat', 'lon'),ds_new[var[vv]])},
                                 {'time': time,
                                  'lat':lat, #ds_new['lat'],
                                  'lon':lon}) # ds_new['lon']})
            ds_new2 = ds_new2.transpose('lon','lat','time')

            if ds_data is None:
                ds_data = xr.Dataset({var[vv]+'_'+rr:ds_new2[var[vv]]})
            else:
                ds_new3 = xr.Dataset({var[vv]+'_'+rr:ds_new2[var[vv]]})
                ds_data = xr.merge([ds_data,ds_new3])
                del ds_new3
            
        print ds_data
    return(ds_data)
    
    
    
    


def shiftmergetime(ds, varis, dt):
#    ds = DEF_30.copy()
#    dt = 30
#    varis = ['rsds','rsus']
##    
#    
    ds_new3 = None
    for varID in varis:
        print '*** '
        ds_new = None
        items = [s for s in ds.keys() if varID in s]
        ds2 = ds.copy()
        j = 0
        
        for i in items:
            if ds_new is None:
                
                firstyear = 1850
                time = pd.date_range(str(firstyear)+'-01-01', 
                                     periods=dt, 
                                     freq='Y').shift(dt*j,freq='Y')
                ds2['time'] = time
                ds_new = ds2[i]
                j = j + 1
            else: 
                
                firstyear = ds2['time'].dt.year.data[0]
                
                if len(items)>5:
                    firstyear = firstyear - dt*len(items)/4
                    
                time = pd.date_range(str(firstyear)+'-01-01', 
                                     periods=dt, 
                                     freq='Y').shift(dt*j,freq='Y')
                ds2['time'] = time
                
                
                ds_new = xr.concat([ds_new, ds2[i]], dim='time')
                j = j + 1
        
        ds_new2 = xr.Dataset({varID:(('lon', 'lat', 'time'), ds_new.values)},
                              {'lon': ds_new['lon'],
                               'lat': ds_new['lat'],
                               'time': ds_new['time']})
        del(ds_new)
        
        if ds_new3 is None:
            ds_new3 = ds_new2
            del(ds_new2)
        else:
            ds_new3 = xr.merge([ds_new3, ds_new2])
            
    return ds_new3





def myround(x, base=0.5):
        return round(base*round(x/base), 2)        




def ensmean(variables,data):
    data_ensmean = None
    for vv in variables:
        items = [s for s in data.keys() if vv in s]
        data_mean2 = data[items].to_array().mean(axis=0).to_dataset(name=vv)
        if data_ensmean is None:
            data_ensmean = data_mean2
        else: 
            data_ensmean = xr.merge([data_ensmean,data_mean2])
    return data_ensmean


def ensmeans(variables,data,models):
#    variables = ['treeFrac']
#    data = DEF_mean
#    models = models
    
    data_ensmean = None
    for model in models:            
        itemsM = [s for s in data.keys() if model in s] # all keys with model 
    
        for vv in variables:
            itemsV = [s for s in itemsM if vv in s] # thereof all keys with var
            
            data_mean2 = data[itemsV].to_array().mean(axis=0).to_dataset(name=vv+'_'+model)
            
            if data_ensmean is None:
                data_ensmean = data_mean2
            else: 
                data_ensmean = xr.merge([data_ensmean,data_mean2])
    return data_ensmean
        


#%%  DEFINE VARIABLES
mistral = False        

regions = ['_glob','_soam','_africa','_sea_aust','_noam_temp','_noam_bor','_eura_bor','_eura_temp']
regions_names = ['Global','South America','Africa','SE Asia & Aust.','North Am. temp.','North Am. bor.','Eurasia bor.','Eurasia temp.']

models = ['MPI','IPSL','CESM2','Can','CNRM','BCC','MIROC','UKESM','EC']
models_name = pd.DataFrame({'IPSL': ['IPSL-CM6A-LR'],
                            'MPI': ['MPI-ESM-1.2.0'],
                             'CESM2': ['CESM2'],
                             'Can': ['CanESM5'],
                             'CNRM': ['CNRM-ESM2-1'],
                             'BCC': ['BCC-CSM2-MR'],
                             'MIROC': ['MIROC-ES2L'],
                             'UKESM':['UKESM1-0-LL'],
                             'EC':['EC-Earth3-Veg']})


timstat = 'year'

meta = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                              'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[150, 80,  80, 90, 80, 81,150, 80, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90,90,90, 90],
                     'nruns':[7,3, 3, 2, 1, 1, 1, 1, 1],
                     'runs': [['r1i1p1f1','r2i1p1f1','r3i1p1f1','r4i1p1f1',\
                               'r5i1p1f1','r6i1p1f1','r7i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p2f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1']]\
                               }).set_index('model')
    
metaCTL = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                                 'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[150, 80,  80, 90, 80, 81, 90, 90, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90, 90, 90, 90],
                     'nruns':[ 7, 3, 1, 2, 1, 1, 1, 1, 1],
                     'runs': [['piControl'],
                              ['piControl'],
                              ['piControl'],\
                              ['piControl'],\
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl']]}).set_index('model')
cexx = 10
cexx2 = 12    
#%%    
### =============================================
#### READ in VARIABLES 
### =============================================
rr = 0
timstat = 'year'
typ = '_'

varinfo = pd.DataFrame({'var':['tas',
                               'pr',
                               'gpp',
                               'cLand',
                               'cVeg','cSoil','cLitter',
                               'cSoilFast','cSoilSlow','cSoilMedium',
                               'evspsbl','npp','rh','nep','fFire',
                               'ts','hfss','hfls','rsus','rsds','rlds',
                               'albedo',
                               'clt','rldscs',
                               'prtas', 'rldsdiff'],
                     'name':['$\Delta$Near-Surface Temperature',
                             '$\Delta$Precipitation',
                             '$\Delta$GPP',
                             '$\Delta$Total Land Carbon',
                             '$\Delta$Vegetation Carbon',
                             '$\Delta$Soil Carbon',
                             '$\Delta$Litter Carbon',
                             '$\Delta$Soil Carbon (fast)',
                             '$\Delta$Soil Carbon (slow)',
                             '$\Delta$Soil Carbon (medium)',
                             '$\Delta$Evapotranspiration',
                             '$\Delta$NPP',
                             '$\Delta$Het. respiration',
                             '$\Delta$NEP',
                             '$\Delta$Fire Emissions',
                             '$\Delta$Surface Temperature',
                             '$\Delta$Sensible Heat Flux',
                             '$\Delta$Latent Heat Flux',
                             '$\Delta$Outgoing Shortwave Radiation',
                             '$\Delta$Incoming Shortwave Radation',
                             '$\Delta$Incoming Longwave Radiation',
                             '$\Delta$Albedo',
                             '$\Delta$Cloud Cover Fraction',
                             '$\Delta$Incoming Longwave Radation (clear sky)',
                             '$\Delta$Pr/$\Delta$Tas',
                             '$\Delta$Longwave - $\Delta$Longwave clear sky'] ,
                     'name_short': ['$\Delta$Tas',
                             '$\Delta$Pr',
                             '$\Delta$GPP',
                             '$\Delta$cLand',
                             '$\Delta$cVeg',
                             '$\Delta$cSoil',
                             '$\Delta$cLitter',
                             '$\Delta$cSoil (fast)',
                             '$\Delta$cSoil (slow)',
                             '$\Delta$cSoil (medium)',
                             '$\Delta$ET',
                             '$\Delta$NPP',
                             '$\Delta$rh',
                             '$\Delta$NEP',
                             '$\Delta$fFire',
                             '$\Delta$T$_s$',
                             '$\Delta$Q$_S$',
                             '$\Delta$Q$_H$',
                             '$\Delta$SW$_U$',
                             '$\Delta$SW$_D$',
                             '$\Delta$LW$_D$',
                             '$\Delta$Albedo',
                             '$\Delta$CLT',
                             '$\Delta$LW$_D$ clear sky',
                             '$\Delta$PrTas',
                             '$\Delta$rlds - $\Delta$rldscs'] ,
                     'unit': ['$^\circ$C',
                              'mm '+timstat+'$^{-1}$',
                              'kg m$^{-2}$'+timstat+'$^{-1}$',
                              'kg m$^{-2}$','kg m$^{-2}$','kg m$^{-2}$','kg m$^{-2}$',
                              'kg m$^{-2}$','kg m$^{-2}$','kg m$^{-2}$',
                              'mm '+timstat+'$^{-1}$',
                              'kg m$^{-2}$ '+timstat+'$^{-1}$',
                              'kg m$^{-2}$ '+timstat+'$^{-1}$',
                              'kg m$^{-2}$ '+timstat+'$^{-1}$',
                              'kg m$^{-2}$ '+timstat+'$^{-1}$',
                              'K','W m$^{-2}$','W m$^2{-2}$',
                              'W m$^{-2}$','W m$^{-2}$','W m$^{-2}$',
                              '%',
                              '%','W m$^{-2}$',
                              'mm/degC',
                              'W m$^{-2}$'],
                     'rm':[30,30,10,10,10,10,10,10,10,10,
                           30,10,10,10,10,
                           30,30,30,30,30,30,
                           30,30,30,
                           30,30],
                    'minmax':[2.5,500,1.0,20.0,
                              15,5,2,0.6,0.6,0.6,
                              400,0.5,0.5,0.5,0.25,
                              2.5,50,50,
                              30,30,10,
                              20, 5, 10,2,10],
                    'minmax_scaled':[8.0,500,1.0,50.00,
                                     20,10,5,0.6,0.6,0.6,
                                     400,0.5,0.5,0.25,0.25,
                                     2.5,100,100,
                                     30,30,30,50,
                                     30, 100,20,100]\
                               }).set_index('var')    

    
    
#%%  READ IN DATA / DO TESTING FOR SIGNIFICANCE / SAVE DATA
case = '_ToE' ## '_ToE' or '' ;; take all years and not only up to 80
    
    
for model in models:    
    
    if mistral == True:
        savepath = "/Users/lenaboysen/mistral/LUMIP/" 
        path="/Users/lenaboysen/mistral/LUMIP/"+model+"/"
    else:
        savepath = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"
        path = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"+model+"/"
        
    def_file = savepath + 'def_mask_regions.obj'
    if os.path.isfile(def_file):
        print 'loading def mask for ' + model
        def_mask_regions = pickle.load(open(def_file,'rb'))
        def_mask = def_mask_regions[model][model+'_defmask_glob']
        diff = def_mask_regions[model][model+'_deffrac_glob']
#        plt.pcolormesh(diff)
#        plt.colorbar()
#        plt.show()
        
    variables = ['tas','pr',
                 'cLand','cVeg','cSoil','cSoilSlow','cSoilFast','cLitter',
                 'evspsbl',
                 'gpp','npp','rh','nep','fFire',
                 'ts','hfss','hfls','rsus','rsds','rlds',
                 'albedo',
                 'clt','rldscs']
    
    
    if type(variables) == str:
        length = 1
        var = [variables]
    elif type(variables) == list:
        length = np.shape(variables)[0]
        var = variables
    
    #for vv in range(1,np.shape(variables)[0]):
    for vv in [0]: #range(0,len(variables)):
        
        if variables[vv] in ['fFire','NEPfFire'] and not model in ['MPI','CESM2','EC']:
            continue
        if model == 'CESM2' and variables[vv] in ['rldscs']:
            continue
#        if model == 'CNRM' and variables[vv] in ['fFire']:
#            continue
        if model == 'Can' and variables[vv] in ['cSoilSlow','cSoilFast','cSoilMedium']:
            continue            
        if model == 'EC' and variables[vv] in ['cSoilSlow','cSoilFast','cSoilMedium']:
            continue          
        if model == 'BCC' and variables[vv] in ['cSoilFast']:
            continue    
        if model == 'MPI' and variables[vv] in ['cSoilMedium']:
            continue   
        if model == 'IPSL' and variables[vv] in ['cSoilMedium']:
            continue   
        if model == 'UKESM' and variables[vv] in ['cSoilSlow','cLitter','fFire']:
            continue           
                                    

                  
        if var[vv] == 'albedo':
            DEF = read_data(['rsus','rsds'],timstat,model,path,meta.loc[model]['runs'])
            CTL = read_data(['rsus','rsds'],timstat,model,path,['piControl']) 
            
        elif var[vv] == 'avail':
            DEF = read_data(['rsus','rsds','rlds'],timstat,model,path,meta.loc[model]['runs'])
            CTL = read_data(['rsus','rsds','rlds'],timstat,model,path,['piControl'])
        elif var[vv] == 'bowen':
            DEF = read_data(['hfss','hfls'],timstat,model,path,meta.loc[model]['runs'])
            CTL = read_data(['hfss','hfls'],timstat,model,path,['piControl'])
        elif var[vv] == 'Tau':
            DEF = read_data(['cSoil','rh'],timstat,model,path,meta.loc[model]['runs'])
            CTL = read_data(['cSoil','rh'],timstat,model,path,['piControl']) 
        elif var[vv] == 'prtas':
            DEF = read_data(['pr','tas'],timstat,model,path,meta.loc[model]['runs'])
            CTL = read_data(['pr','tas'],timstat,model,path,['piControl'])             
        else:   
            DEF = read_data(var[vv],timstat,model,path,meta.loc[model]['runs'])
            CTL = read_data(var[vv],timstat,model,path,['piControl'])
    
#        plt.pcolormesh(DEF['evspsbl_r1i1p1f1'].isel(time = 50))
#        plt.colorbar()
#        plt.show()
#        plt.pcolormesh(CTL['evspsbl_piControl'].isel(time = 50))
#        plt.colorbar()
#        plt.show()    
    
        ### =============================================
        #### ADJUST DATA FORMAT
        ### =============================================
        
        
        ### for ToE
        if case == '_ToE':
            DEF_30 = DEF.isel(time=slice(meta.loc[model]['imax']-varinfo.loc[var[vv]]['rm'], 
                                         meta.loc[model]['imax']))
            CTL_30 = CTL.isel(time=slice(meta.loc[model]['imaxctl']-varinfo.loc[var[vv]]['rm'],meta.loc[model]['imaxctl']))

        
        else:
            ### take only t50 to t80
            DEF_30 = DEF.isel(time=slice(80-varinfo.loc[var[vv]]['rm'],80))
        
        ### Take either last 30 years or first
        ### --> now first to avoid drifts in some 
        ### models and have same starting point
        
#        CTL_30 = CTL.isel(time=slice(meta.loc[model]['imaxctl']-varinfo.loc[var[vv]]['rm'],meta.loc[model]['imaxctl']))
        ## BCC drifts, so take first years
#        if model == 'BCC':
            CTL_30 = CTL.isel(time=slice(0,varinfo.loc[var[vv]]['rm']))
        
#        CTL_90 = CTL.isel(time=slice(meta.loc[model]['imaxctl']-rm*3,\
#                                     meta.loc[model]['imaxctl'])).rename(\
#                                     {var[vv]+'_piControl': var[vv]})
        
        if var[vv] == 'albedo':
            DEF_90 = shiftmergetime(DEF_30, ['rsus','rsds'],\
                                    dt=varinfo.loc[var[vv]]['rm'])
            CTL_90 = CTL.rename({'rsds_piControl': 'rsds'}) 
            CTL_90 = CTL_90.rename({'rsus_piControl': 'rsus'}) 
            CTL_data = CTL_90['rsus'].data / CTL_90['rsds'].data * 100
            DEF_data = DEF_90['rsus'].data / DEF_90['rsds'].data * 100   
            varid = 'rsus'
            
        elif var[vv] == 'avail':
            DEF_90 = shiftmergetime(DEF_30, ['rsus','rsds','rlds'], 
                                    dt=varinfo.loc[var[vv]]['rm'])
            CTL_90 = CTL.rename({'rsds_piControl': 'rsds'}) 
            CTL_90 = CTL_90.rename({'rsus_piControl': 'rsus'}) 
            CTL_90 = CTL_90.rename({'rlds_piControl': 'rlds'})
            
            CTL_data = CTL_90['rsus'].data - CTL_90['rsds'].data + \
                        CTL_90['rlds'].data                    
            DEF_data = DEF_90['rsus'].data - DEF_90['rsds'].data + \
                        DEF_90['rlds'].data   
            varid = 'rsus'                    
        elif var[vv] == 'bowen':
#            DEF_90 = shiftmergetime(DEF_30, ['rsus','rsds'], dt=varinfo.loc[var[vv]]['rm'])
#            CTL_90 = CTL.rename({var[vv]+'_piControl': var[vv]})   
            CTL_data = CTL_90['hfss'].data / CTL_90['hfls'].data
            DEF_data = DEF_90['hfss'].data / DEF_90['hfls'].data 
            varid = 'hfss'
        elif var[vv] == 'prtas':
            DEF_90 = shiftmergetime(DEF_30, ['pr','tas'], dt=varinfo.loc[var[vv]]['rm'])
            CTL_90 = CTL.rename({'pr_piControl': 'pr'})   
            CTL_90 = CTL_90.rename({'tas_piControl': 'tas'}) 
            CTL_data = CTL_90['pr'].data / CTL_90['tas'].data
            DEF_data = DEF_90['pr'].data / DEF_90['tas'].data 
            varid = 'prtas'            
        elif var[vv] == 'Tau': 
#            DEF_90 = shiftmergetime(DEF_30, ['rsus','rsds'], dt=varinfo.loc[var[vv]]['rm'])
#            CTL_90 = CTL.rename({var[vv]+'_piControl': var[vv]})   
            DEF_data = xr.where(DEF_90['rh'] >= 0.0, 
                                DEF_90['cSoil']/DEF_90['rh'],0).data
            CTL_data = xr.where(CTL_90['rh'] >=0.0, 
                                CTL_90['cSoil'] / CTL_90['rh'],0).data
            varid = 'Tau'              
        else:
            DEF_90 = shiftmergetime(DEF_30, [var[vv]], dt=varinfo.loc[var[vv]]['rm'])
            CTL_90 = CTL.rename({var[vv]+'_piControl': var[vv]})   
            CTL_data = CTL_90[var[vv]].data
            DEF_data = DEF_90[var[vv]].data
            varid = var[vv] 
            
            
        
        lat = DEF_90[DEF_90.keys()[0]]['lat'].data
        lon = DEF_90[DEF_90.keys()[0]]['lon'].data

        
        ### =============================================
        ### modified t-Test (t-statistic = t^)
        ### =============================================
#        test3d = ttest.modTtest3d(CTL_data,DEF_data,alternative="greater",conf_level=0.95) 
        test3d = ttest.modTtest3d(CTL_data,DEF_data,alternative="two_sided",conf_level=0.95) 
        pval = test3d['pvalue'][:,:]
#        mask =  (pval < 0.975) and (pval > 0.025)# True is masked out

        mask = np.where((pval>0.025) & (pval<0.975), True, False)
        
        
#        scaled=False
#        if scaled == False: 
        var_masked = np.ma.masked_array(DEF_data.mean(-1)-CTL_data.mean(axis=-1), mask)
#        else:
#            diff = (DEF_90[var[vv]].mean('time')-CTL_90[var[vv]].mean('time'))
#            deffrac = np.abs(def_mask_regions[model][model+'_deffrac_glob'])/100.
#            scale = diff.where(deffrac > 0., diff/ deffrac)
#            var_masked = np.ma.masked_array(scale.data, mask)
        
        
        if model == 'CESM' and var[vv] == 'pr':
            var_masked  = var_masked * 86400
        
        
        ds = xr.Dataset({'var_masked': (('lon', 'lat'), var_masked),
                         'def_mask':(('lon','lat'), def_mask),
                         model + '_CTL_'+var[vv]:(('lon','lat'), CTL_data.mean(axis=-1)),
                         model + '_DEF_'+var[vv]:(('lon','lat'), DEF_data.mean(axis=-1))},
                        {'lon': lon, 'lat': lat})

                    
        print var[vv]
        print 'DEF'
        plt.pcolormesh(DEF_data.mean(-1))
        plt.colorbar()
        plt.show()
        print 'CTL'
        plt.pcolormesh(CTL_data.mean(-1))
        plt.colorbar()
        plt.show()
        print 'DIFF'
        plt.pcolormesh(CTL_data.mean(-1)-DEF_data.mean(-1))
        plt.colorbar()
        plt.show()                
        
        file_out = open(savepath + var[vv] + '_' + model +'_map'+case+'.obj','w')
        pickle.dump(ds, file_out)
        file_out.close() 
        
        
#        ### save as netCDF
#        ds.to_netcdf(savepath + var[vv] + '_' + model +'_map.nc','w')
        