'''
README for LUMIP analysis

Download data from ESGF: experiment name: deforest-globe and piControl



Create annual means and sums using CDOs: prepare_output.j


NOTES and additional data files:
    
    
- MIROC: extract treefrac from deforest_frac (primary to secondary vegetation)
--> forestfrac.MIROC-ES2L.LUMIP-deforestGlob.nc and MIROC_readme01.docx provided.
-- deforestation is the difference of 1900-1850 in the experiment simulation (no piControl file available)

cdo -mulc,-1 -mul -divc,100 sftlf.nc -invertlat -yearmean treeFrac_Lmon_MIROC-ES2L_deforest-globe_r1i1p1f1_gn_185001-199912.nc treeFrac_MIROC_year.nc


- EC-Earth: 
cdo -s -L --reduce_dim -sellevel,1 -expr,"deforested=(fracOutLut>0.00001)" deforestGlobe_fracOutLut_1850-1929.nc lut.nc
cdo -sub -selyear,1902 lut.nc -selyear,1851 lut.nc lut_diff.nc

treeFrac: Take yearmax instead of yearmean 

cdo ifthen sftlf_nan.nc deforestGlobe_treeFrac_1850-1929_ECE.nc deforestGlobe_treeFrac_1850-1929_ECE_sftlf.nc
cdo -O -setname,treeFrac -yearmax deforestGlobe_treeFrac_1850-1929_ECE.nc treeFrac_EC_year.nc\

fFire: selmon,12 (rest is 0)
    


- CNRM: landCoverFrac 
cdo -setname,treeFrac -mulc,100 -selvar,forestFrac landCoverFrac_Lyr_CNRM-ESM2-1_deforest-globe_r1i1p1f2_gr_185001-193012.nc treeFrac_Lmon_CNRM-ESM2-1_deforest-globe_r1i1p1f2_gr_185001-193012.nc
-- deforestation is the difference of 1900-1850 in the experiment simulation (no piControl file available)



- BCC:
-- deforestation is the difference of 1900-1850 in the experiment simulation (no piControl file available)
surface-data.deforest.320x160.nc
cdo -setname,treeFrac -selvar,PCT_FOREST surface-data.deforest.320x160.nc r1i1p1f1/treeFrac_BCC_year.nc






Python (analysis & visualization)
1. LUMIP_calc_deffrac.py
    execute to load all deforestation maps, fractions and masks
    
1b. LUMIP_plot_treefrac_map.py Fig. 1, S1
1c. LUMIP_plot_treefrac_ts.py  Fig. S2

2. LUMIP_MAP_read_save_data.py
	read in annual data, significance testing, saving processed data
2b. LUMIP_plot_map.py
	read processed data and plot
	Fig. 2, 7, 9, S5-S10, S15, S16, S20, S21

3. LUMIP_TS_read_save_data.py
	read in annual data, global means and significance testing, writing out excel sheets with values (Table 1), saving processed data
3b. LUMIP_plot_TS.py
	plot time series  
	Fig. 5, 8, 10, S17

4. LUMIP_plot_calc_SEB.py
	read and calc Surface energy balance decomposition. 
	Fig. 3, S3, S4

5. LUMIP_calc_nonlinear_alaWinckler.py
	Read, calculate and plot non-linear relationship between deforestation fraction and Tas or cLand
	Fig. 4, S11, S22, S23

6. LUMIP_calc_plot_ToE.py
	read, calculate and plot Time of Emergence and Fraction of Emergence for Tas, cLand and GPP
	Fig. 6, S12, S13, S18, S19

7. LUMIP_calc_plot_dPvsdT.py
	read, calculate and plot relationship between dTas and dPrecip
	Fig. S14


'''