#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Thu May 28 08:38:04 2020

@author: lenaboysen


READ in data, make global means/sums, test for significance, export table


"""



import os
import numpy as np
np.set_printoptions(threshold=100) # 'nan'
import os.path
import sys as sys
import pickle

#import cdo
#cdo = cdo.Cdo()
#cdo.setCdo('/opt/local/bin/cdo')
import xarray as xr
#from matplotlib import gridspec
#from datetime import datetime, date


#plot
import matplotlib.pyplot as plt
#import matplotlib as mpl
#import matplotlib.colors as colors
import seaborn as sns; sns.set(color_codes=True)

#import plotly.plotly as py
#import plotly.graph_objs as go
import pandas as pd


new_path = '/Users/lenaboysen/Google Drive/python/'
if new_path not in sys.path:
    sys.path.append(new_path)
    
#from mod_tTest import *
import mod_tTest as ttest

 
#% Constants
kg_C_per_kg_CO2 = 0.272918
kg_C_perMol = 0.012011
C_to_K = 273.15
MPa_to_mm = 1022.8

#%% FUNCTIONS
def read_data(var,timstat,model,path,runs,lat=None,lon=None,calc_deffrac=False):
#    var = ['treeFrac']
#    timstat = 'year'
##    path = "/Users/lenaboysen/mistral/LUMIP/CESM/"
#    length = 1
#    vv = 0;
#    runs = ['r1i1p1f2']
#    rr = 'r1i1p1f2'
    
    if type(var) == str:
        length = 1
        var = [var]
    elif type(var) == list:
        length = np.shape(var)[0]
        
    ds_data = None
    for vv in range(0,length):       
        for rr in runs: 
            
#            print 'read in exp = '+ model+ ' '+ rr + ' ' + ' '+ var[vv]
            print path + rr +'/'+var[vv]+'_'+model+'_'+timstat+'.nc'
            ds_new = xr.open_dataset(path + rr +'/'\
                                     +var[vv]+'_'+model+'_'+timstat+'.nc',\
                                     cache=False, decode_times=False)
            ds_new.close()
    
#            print ds_new[var[vv]].shape # dsA.cveg.coords, dsA.cveg.dims, dsA.info
            ### Data must be in shape  lon, lat, time!!
            if var[vv] != 'cellarea':
                nt = np.shape(ds_new['time'])[0]
                if timstat == 'year':
                    ff = 'y'
                else:
                    ff = 'm'
                    
                if lat is None and (rr == runs[0] or rr == 'piControl'):
                    lat = ds_new['lat'].values
                if lon is None and (rr == runs[0] or rr == 'piControl'):
                    lon = ds_new['lon'].values 
                    
                    
                ### comment out if def_mask_regions is only created now!   
                if model == 'CESM2' and calc_deffrac == False:
                    lat = def_mask_regions[model][model+'_deffrac_glob'].lat
                
                startyear = 1850
                time = pd.date_range(str(startyear)+'-01-01', periods=nt, freq=ff)
                ds_new2 = xr.Dataset({var[vv]:(('time', 'lat', 'lon'),ds_new[var[vv]])},
                                     {'time': time,
                                      'lat':lat, #ds_new['lat'],
                                      'lon':lon}) # ds_new['lon']})
                ds_new2 = ds_new2.transpose('lon','lat','time')
    
                if ds_data is None:
                    ds_data = xr.Dataset({var[vv]+'_'+rr:ds_new2[var[vv]]})
                else:
                    ds_new3 = xr.Dataset({var[vv]+'_'+rr:ds_new2[var[vv]]})
                    ds_data = xr.merge([ds_data,ds_new3])
                    del ds_new3
            else:
                if ds_data is None:
                    ds_data = xr.Dataset({var[vv]+'_'+rr: 
                                        (('lon','lat'),ds_new[var[vv]].transpose('lon','lat'))},
                                          {'lon':lon, 'lat': lat})
                else:
                    ds_new3 = xr.Dataset({var[vv]+'_'+rr: 
                                        (('lon','lat'),ds_new[var[vv]].transpose('lon','lat'))},
                                          {'lon':lon, 'lat': lat})
                    ds_data = xr.merge([ds_data,ds_new3])
                    del ds_new3
            
#        print ds_data
    return(ds_data)


def create_defmask(CTL, DEF, maskvar, cutoff = 0.001):
    ### 1. select keys containing vars, ensmean over them
    ### 2. mean over last 10 years of DEF and CTL
#    DEF = DEF
#    CTL = CTL
#    maskvar = maskvar
    
    if type(maskvar) == str:
        maskvar = [maskvar]
    if model == 'BCC':
           
        DEF_mean = DEF.loc[dict(time='1900-12-31')]
        CTL_mean = CTL.loc[dict(time='1900-12-31')]
    else:    
        DEF_mean = DEF.loc[\
                dict(time=slice('1920-01-01','1929-12-31'))].mean('time')
        CTL_mean = CTL.loc[\
                dict(time=slice('1920-01-01','1929-12-31'))].mean('time')
    
    DEF_ensmean = ensmean(maskvar, DEF_mean)
    CTL_ensmean = ensmean(maskvar, CTL_mean)
    
    cf = CTL_ensmean['treeFrac'].values/100
    
    if model in ['CESM2','BCC','CNRM']:
        diff = (DEF_ensmean['treeFrac'] -\
                DEF['treeFrac_'+meta.loc[model]['runs'][0]].loc[dict(time='1850-12-31')].rename(\
                        {'treeFrac'})).values 
#    elif model == 'BCC':
#        diff = (DEF['treeFrac_r1i1p1f1'].loc[dict(time='1930-12-31')].rename(\
#                        {'treeFrac'})).values -\
#                (DEF['treeFrac_r1i1p1f1'].loc[dict(time='1850-12-31')].rename(\
#                        {'treeFrac'})).values
                       
    else:
        diff = (DEF_ensmean - CTL_ensmean)['treeFrac'].values 
    
    def_mask = np.zeros(np.shape(diff))
    diff_helper = np.copy(diff)
    diff_helper[np.isnan(diff)] = 0
    
    def_mask[ diff_helper < -cutoff ] = 1
    def_mask[ diff_helper >= -cutoff ] =  0# np.nan
    
    plt.pcolormesh(def_mask)
    plt.colorbar()
    plt.show()
    
    return cf, diff, def_mask


def ensmean(variables,data):
#    variables = maskvar
#    data = DEF_mean
    
    data_ensmean = None
    for vv in variables:
        items = [s for s in data.keys() if vv in s]
        data_mean2 = data[items].to_array().mean(axis=0).to_dataset(name=vv)
        if data_ensmean is None:
            data_ensmean = data_mean2
        else: 
            data_ensmean = xr.merge([data_ensmean,data_mean2])
    return data_ensmean




def create_defmask_regions(cf, diff, def_mask, model, lon, lat):


    regions_lonlat = xr.Dataset({'_glob':([lon[0],lon[len(lon)-1],
                                           lat[0],lat[len(lat)-1]]),
                                 '_soam':([250,330,-60,25]),                             
                                 '_africa':([340,360,-45,36]),
                                 '_africa2':([0,43,-40,36]),                             
                                 '_sea_aust':([45,180,-48,37]),                             
                                 '_noam_temp':([230,330,26,50]),                             
                                 '_noam_bor':([190,329,50,80]),                             
                                 '_eura_bor':([0,180,60,80]), 
                                 '_eura_bor2':([330,360,60,80]),                              
                                 '_eura_temp':([0,160,36,60]),
                                 '_eura_temp2':([350,360,36,60])})

    
    def_mask_regions = xr.Dataset()
    for rr in range(0,8):
        print regions[rr]
        def_mask2 = def_mask.copy()
        diff2 = diff.copy()
        cf2 = cf.copy()
        
        
    #    newmask = np.ones((len(lon),len(lat))) ## ones are masked out
        if rr == 0:
            newmask = xr.Dataset({'region':(('lon','lat'),
                                np.zeros((len(lon),len(lat))))},
                                {'lat': lat, 'lon': lon})
        else:
            newmask = xr.Dataset({'region':(('lon','lat'),
                                            np.ones((len(lon),len(lat))))},
                                {'lat': lat, 'lon': lon})
            newmask['region'].loc[dict(
                    lon=slice(regions_lonlat[regions[rr]].values[0],
                    regions_lonlat[regions[rr]].values[1]),
                    lat=slice(regions_lonlat[regions[rr]].values[2],
                    regions_lonlat[regions[rr]].values[3]))] = 0 
    
            if regions[rr] == '_africa':
                newmask['region'].loc[dict(
                    lon=slice(regions_lonlat['_africa2'].values[0],
                              regions_lonlat['_africa2'].values[1]),
                    lat=slice(regions_lonlat['_africa2'].values[2],
                              regions_lonlat['_africa2'].values[3]))] = 0 
            if regions[rr] == '_eura_temp':
                newmask['region'].loc[dict(
                    lon=slice(regions_lonlat['_eura_temp2'].values[0],
                              regions_lonlat['_eura_temp2'].values[1]),
                    lat=slice(regions_lonlat['_eura_temp2'].values[2],
                              regions_lonlat['_eura_temp2'].values[3]))] = 0                       
            if regions[rr] == '_eura_bor':
                newmask['region'].loc[dict(
                    lon=slice(regions_lonlat['_eura_bor2'].values[0],
                              regions_lonlat['_eura_bor2'].values[1]),
                    lat=slice(regions_lonlat['_eura_bor2'].values[2],
                              regions_lonlat['_eura_bor2'].values[3]))] = 0                                                
#        plt.pcolormesh(newmask['region'].values,cmap='RdBu')
#        plt.colorbar()
#        plt.show()
        newmask = newmask['region'].values
        
        ## regions: lonlat boxes
        ## deffrac: only deforestation area of lonlatbox
        ## cf: cover fractions CTL
        dummy = xr.Dataset({model +regions[rr]: (('lon','lat'), newmask),
                            model +'_defmask'+regions[rr]: (('lon','lat'),
                                             np.ma.masked_array(def_mask2, newmask)),
                            model +'_deffrac'+regions[rr]: (('lon','lat'),
                                             np.ma.masked_array(diff2, newmask)),
                            model +'_cf'+regions[rr]: (('lon','lat'),
                                        np.ma.masked_array(cf2, newmask))},
                                            {'lon': lon, 'lat': lat})
    
        if rr == 0:
            def_mask_regions = dummy
        else:
            old = def_mask_regions
            def_mask_regions = xr.merge([old, dummy])
            
    return def_mask_regions



def ensmean_reg(variables,data,model,nregs=range(0,8)):
#    variables = [var]
#    data = CTL_ts
    if type(variables) == str:
        variables = [variables]    
    data_ensmean = None   
    for vv in variables:
        itemsV = [s for s in data.keys() if vv in s]
        for rr in nregs:
            itemsR = [s for s in itemsV if regions[rr] in s]
            for tt in ['', 'GD']:
                itemsGD = [s for s in itemsR if vv+tt+regions[rr] in s]
        
                data_mean2 = data[itemsGD].to_array().mean(axis=0).to_dataset(
                        name=model+'_'+vv+tt+regions[rr])
                
                if data_ensmean is None:
                    data_ensmean = data_mean2
                else: 
                    data_ensmean = xr.merge([data_ensmean,data_mean2])
    return data_ensmean



def shiftmergetime(ds, var, runs, dt):
#    ds = CTL_30.copy()
#    dt = 30
#    var = 'tas'
#    
    firstyear = ds['time'].dt.year.data[0]
    ds_out = None
    ## all keys with variable
    itemsV = [s for s in ds.keys() if var in s] 
        ## thereof all keys with region 
    for rr in range(0,8):
        itemsR = [s for s in itemsV if regions[rr] in s]

        for typ in [var+regions[rr],var+'GD'+regions[rr]]:
            itemsT = [s for s in itemsR if typ in s]
            ds_new = None; 
            j = 0
            for i in itemsT:
                if ds_new is None:
                    ds_new = ds[i]
                    j = j + 1
                else: 
#                    if len(runs)>5:
#                        firstyear = firstyear - dt*len(runs)/2
                    time = pd.date_range(str(firstyear)+'-01-01', 
                                         periods=dt, 
                                         freq='Y').shift(dt*j,freq='Y')
                    ds2 = ds[i]
                    ds2['time'] = time
                    ds_new = xr.concat([ds_new,ds2],dim='time')
                    j = j + 1
                    
             
                ds_new3 = xr.Dataset({model+'_'+typ:(('time'), ds_new.values)},
                                  {'time': ds_new['time']})        
                if ds_out is None:  
                    ds_out = ds_new3
                else:
                    ds_out = xr.merge([ds_out, ds_new3])
                
    return ds_out



def myround(x, base=0.5):
        return round(base*round(x/base), 2)        


def cutregions(data_var, var, runs, model, def_mask_regions, nregs=range(0,8)):
#    data_var = DEF.copy()
#    var = ['tas']
#    nregs=range(0,7)
#    runs = meta.loc[model]['runs']
#    def_mask_regions = def_mask_regions
#    model = model
    lat = data_var.lat.values
    lon = data_var.lon.values
    
    if type(var) == str:
        length = 1
        var = [var]
    elif type(var) == list:
        length = np.shape(var)[0]
    
    data_out = None
    for vv in range(0,length):
        
        items = [s for s in data_var.keys() if var[vv] in s]
        data_time = data_var[items[0]]['time']
        data_t = len(data_time)
        
        for rr in nregs:
            data = data_var[items].copy(deep=True)
         
            for run in runs:
                print var[vv] + ' ' + regions_names[rr] + ' ' + run
                
                regmask = def_mask_regions[model][
                            model + regions[rr]].copy(deep=True)
                regmask2 = xr.where(regmask > 0, 1, 0)

                def_regmask = def_mask_regions[model][
                            model+'_defmask'+regions[rr]].copy(deep=True)
                def_regmask2 = xr.where(def_regmask > 0, 0, 1)               
                                                
                regions_t = np.repeat(np.expand_dims(
                                regmask2.copy(deep=True),2),data_t,axis=2)
                regions_def_t = np.repeat(np.expand_dims(
                                def_regmask2.copy(deep=True),2),data_t,axis=2)

                if rr > 0:
                    data_regbox = np.ma.masked_array(
                            data[var[vv]+'_'+run].copy(deep=True),regions_t)
                    data_regdef = np.ma.masked_array(
                            data[var[vv]+'_'+run].copy(deep=True),regions_def_t)
                else:
                    data_regbox = data[var[vv]+'_'+run].copy(deep=True)
                    data_regdef = np.ma.masked_array(
                            data[var[vv]+'_'+run].copy(deep=True),regions_def_t)

                ds1 =  xr.Dataset({model+'_'+var[vv]+regions[rr]+'_'+run: 
                                            (('lon','lat','time'),data_regbox),
                                   model+'_'+var[vv]+'GD'+regions[rr]+'_'+run:
                                            (('lon','lat','time'),data_regdef)},
                                        {'lon': lon, 'lat': lat,'time': data_time})                                
                if data_out is None:
                    data_out = ds1
                else:
                    old = data_out
                    data_out = xr.merge([old, ds1])
    return(data_out)



    
def average_ds(self, dim=None, weights=None):
    if weights is None:
        return self.mean(dim)
    else:
        return self.apply(average_ds, dim=dim, weights=weights)



#DEF_reg, dim=['lon','lat'],weights=weights
def average_da(self, dim=None, weights=None):
#    self = DEF_reg #_IPSL
#    weights = weights #_IPSL
#    dim=['lon','lat']
#    
    if weights is None:
        return self.mean(dim)
    else:
        if not isinstance(weights, xr.DataArray):
            raise ValueError("weights must be a DataArray")

        # if NaNs are present, we need individual weights
        if self.notnull().any():
            total_weights = weights.where(self.notnull()).sum(dim=dim)
        else:
            total_weights = weights.sum(dim)

        average_da = (self * weights).sum(dim) / total_weights
        return average_da


def calc_diff_ts(var, DEF_ts, CTL_ts_mean, model,runs,nregs=range(0,8)):
    if type(var) == str:
        var = [var]
    
    ds_out = None
    time = DEF_ts.time
    for vv in var:
        for rr in nregs:
            for typ in [vv+regions[rr], vv+'GD'+regions[rr]]:
                for run in runs:
                    if model in ['CESM2','BCC','MIROC','CNRM'] and vv == 'treeFrac':
                        diff = DEF_ts[model+'_'+typ+'_'+run] -  \
                           CTL_ts_mean[model+'_'+typ+'_'+meta.loc[model]['runs'][0]]
                    else:
                        diff = DEF_ts[model+'_'+typ+'_'+run] -  \
                           CTL_ts_mean[model+'_'+typ+'_piControl']
                    
                    ds = xr.Dataset({model+'_'+typ+'_'+run:(('time'),diff)},
                                         {'time':time})
                    if ds_out is None:
                        ds_out = ds
                    else:
                        ds_out = xr.merge([ds_out, ds])
    return ds_out
                                


#%%  DEFINE VARIABLES
mistral = False
regions = ['_glob','_soam','_africa','_sea_aust','_noam_temp','_noam_bor','_eura_bor','_eura_temp']
regions_names = ['Global','South America','Africa','SE Asia & Aust.','North Am. temp.','North Am. bor.','Eurasia bor.','Eurasia temp.']

models = ['MPI','IPSL','CESM2','Can','CNRM','BCC','MIROC','UKESM','EC']
models_name = pd.DataFrame({'IPSL': ['IPSL-CM6A-LR'],
                            'MPI': ['MPI-ESM-1.2.0'],
                             'CESM2': ['CESM2'],
                             'Can': ['CanESM5'],
                             'CNRM': ['CNRM-ESM2-1'],
                             'BCC': ['BCC-CSM2-MR'],
                             'MIROC': ['MIROC-ES2L'],
                             'UKESM':['UKESM1-0-LL'],
                             'EC':['EC-Earth3-Veg']})


timstat = 'year'

meta = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                              'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[151, 80,  80, 90, 80, 81,150, 80, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90,90,90, 90],
                     'nruns':[7,3, 3, 2, 1, 1, 1, 1, 1],
                     'runs': [['r1i1p1f1','r2i1p1f1','r3i1p1f1','r4i1p1f1',\
                               'r5i1p1f1','r6i1p1f1','r7i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p2f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1']]\
                               }).set_index('model')
    
metaCTL = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                                 'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[151, 80,  80, 90, 80, 81, 90, 90, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90, 90, 90, 90],
                     'nruns':[ 7, 3, 1, 2, 1, 1, 1, 1, 1],
                     'runs': [['piControl'],
                              ['piControl'],
                              ['piControl'],\
                              ['piControl'],\
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl']]}).set_index('model')

## index = rownames; select with meta.loc['IPSL']    
cols = pd.DataFrame({'IPSL': ['orchid','purple'],
                             'CESM': ['orchid','orchid'],
                              'MPI': ['indianred','indianred'],
                              'CESM2':['dodgerblue','dodgerblue'],
                              'Can': ['orange','orange'],
                              'BCC': ['mediumblue','mediumblue'],
                              'CNRM' : ['seagreen','seagreen'],
                              'MIROC' : ['gray','gray'],
                              'UKESM': ['pink','pink'],
                              'EC':['turquoise','turquoise']})
                    
#%% 
### ---------------------------------------
'''
   Read data
'''
### ---------------------------------------

variables = ['tas','pr','cLand','cVeg','cSoil','cSoilSlow','cSoilFast','cLitter',
                'cSoilMedium','evspsbl',
                 'gpp','npp','rh','nep','fFire','NEPfFire','treeFrac',
                 'ts','hfss','hfls','rsus','rsds','rlds','clt','rldscs']

'''
tas = near surf temp = K
ts  = surf temp     = K
tws = surf temp water = K
tsl = soil temp = K

sfcWind = surf Wind = m/s
clt = total cloud fraction = %

pr = precip = mm/yr
et = total ET  = mm/yr
es = bare soil evap 
evspsbl = evap
tran = transpiration
mrro = total runoff
mrros = surface runoff
mrrb = drainage
sbl = surface ice/snow sublimation

mrso total soil moisture        = kg/m2
rzxc = root zone soil moisture

CO2_flux = total upward CO2 flux = kgC/m2yr
CO2_flx_ocean = upward ocean flx (acc)
fFire = C emissions to atm due to fire
fco2nat = C flux to atm from nat (wo LUC!)

netAtmosLandCO2Flux = between land and atm, positive to land from all processes

co2mass = kg/m2
'''
timstat = 'year'
timstr = timstat
types = ['','GD']


varinfo = pd.DataFrame({'var':['tas',
                               'pr',
                               'gpp',
                               'cLand',
                               'cVeg','cSoil','cLitter','cSoilFast','cSoilSlow','cSoilMedium',
                               'treeFrac',
                               'evspsbl',
                               'npp',
                               'fFire',
                               'rh',
                               'nep','NEPfFire',
                               'ts','hfss','hfls','rsus','rsds','rlds',
                               'clt','rldscs'],
                     'name':['$\Delta$Near-Surface Temperature',
                             '$\Delta$Precipitation',
                             '$\Delta$GPP',
                             '$\Delta$Total Land Carbon',
                             '$\Delta$Vegetation Carbon',
                             '$\Delta$Soil Carbon',
                             '$\Delta$Litter Carbon',
                             '$\Delta$Soil Carbon (fast)',
                             '$\Delta$Soil Carbon (slow)',
                             '$\Delta$Soil Carbon (medium)',
                             '$\Delta$Tree cover',
                             '$\Delta$Evapotranspiration',
                             '$\Delta$NPP',
                             '$\Delta$Fire emissions',
                             '$\Delta$Het. respiration',
                             '$\Delta$NEP',
                             '$\Delta$(NEP-fFire)',
                             '$\Delta$Surface Temperature',
                             '$\Delta$Sensible Heat Flux',
                             '$\Delta$Latent Heat Flux',
                             '$\Delta$Outgoing Shortwave Radiation',
                             '$\Delta$Incoming Shortwave Radation',
                             '$\Delta$Incoming Longwave Radiation',
                             '$\Delta$Cloud Cover Fraction',
                             '$\Delta$Incoming Longwave Radation (clear sky)'] ,
                     'name_short': ['$\Delta$Tas',
                             '$\Delta$Pr',
                             '$\Delta$GPP',
                             '$\Delta$cLand',
                             '$\Delta$cVeg',
                             '$\Delta$cSoil',
                             '$\Delta$cLitter',
                             '$\Delta$cSoil (fast)',
                             '$\Delta$cSoil (slow)',
                             '$\Delta$cSoil (medium)',
                             '$\Delta$Tree cover',
                             '$\Delta$ET',
                             '$\Delta$NPP',
                             '$\Delta$fFire',
                             '$\Delta$rh',
                             '$\Delta$NEP',
                             '$\Delta$(NEP-fFire)',
                             '$\Delta$T$_s$',
                             '$\Delta$Q$_S$',
                             '$\Delta$Q$_H$',
                             '$\Delta$SW$_U$',
                             '$\Delta$SW$_D$',
                             '$\Delta$LW$_D$',
                             '$\Delta$CLT',
                             '$\Delta$LW$_D$ clear sky'] ,
                     'unit': ['$^\circ$C',
                              'mm '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC','GtC','GtC','GtC','GtC','GtC','GtC',
                              'Mkm$^2$',
                              'mm '+timstat+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'K','W m$^{-2}$','W m$^{-2}$',
                              'W m$^{-2}$','W m$^{-2}$','W m$^{-2}$',
                              '%','W m$^{-2}$'],
                     'rw':[30,30,10,10,10,10,10,10,10,10,1,30,10,10,10,10,10,
                           30,30,30,30,30,30,30,30],
                     'majorticks': [[-0.7, 0.6, 0.1],\
                                    [-250, 100, 50],\
                                    [-8, 4, 2],\
                                    [-300, 100, 50],\
                                    [-300, 100, 50],\
                                    [-15, 15, 5],\
                                    [-55, 15, 10],\
                                    [-15, 15, 5],\
                                    [-40, 15, 10],\
                                    [-180, 50, 25],\
                                    [-200,50,25],
                                    [-150,50,25],
                                    [-8, 4, 2],
                                    [10, 10, 5],
                                    [10, 10, 5],
                                    [10, 10, 5],
                                    [-0.7, 0.6, 0.1],
                                    [-0.7, 0.6, 0.1],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],]\
                               }).set_index('var')

#%% READ IN DATA / CALC global statistics / CALC t-test / print table / SAVE DATA              


if mistral == True:
    savepath = "/Users/lenaboysen/mistral/LUMIP/"  
else:
    savepath = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"
        
file_out = savepath + 'def_mask_regions.obj'
if os.path.isfile(file_out):
    def_mask_regions = pickle.load(open(file_out,'rb'))
                    
    
                    
if type(variables) == str:
    variables = [variables]

#for vv in range(0,np.shape(variables)[0]):
for vv in range(0,len(variables)): #range(0,13):#,1,3,4,5,6,8]: # range(0,1):
    
    var = variables[vv]

    ### =====================================
    ### Get Data raw (maps)
    ### =====================================   
    df_table = None ## for pval table


    for model in models:  
        Diff_out = None ## for plotting rm
        
        if variables[vv] in ['fFire','NEPfFire'] and not model in ['MPI','CESM2','EC']:
            continue
        if model == 'CESM2' and variables[vv] in ['rldscs']:
            continue
#        if model == 'CNRM' and variables[vv] in ['fFire']:
#            continue
        if model == 'Can' and variables[vv] in ['cSoilSlow','cSoilFast','cSoilMedium']:
            continue            
        if model == 'EC' and variables[vv] in ['cSoilSlow','cSoilFast','cSoilMedium']:
            continue          
        if model == 'BCC' and variables[vv] in ['cSoilFast']:
            continue    
        if model == 'MPI' and variables[vv] in ['cSoilMedium']:
            continue   
        if model == 'IPSL' and variables[vv] in ['cSoilMedium']:
            continue   
        if model == 'UKESM' and variables[vv] in ['cSoilSlow','cLitter','fFire']:
            continue           
        
        ## ==================================================================
        ### =====================================
        ### SAVE/LOAD VARIABLE DATA 
        ### =====================================        
        
        if mistral == True:
            savepath = "/Users/lenaboysen/mistral/LUMIP/"  
            path="/Users/lenaboysen/mistral/LUMIP/"+model+"/"
        else:
            savepath = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"
            path = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"+model+"/"

#        if model in ['MPI','IPSL']:
#            SAVE_DATA = False
#        else:
        SAVE_DATA = True
        SAVE_TS = True
        CALC_tTest = True
        
        if SAVE_DATA == True: 
            lat = def_mask_regions[model].lat
            lon = def_mask_regions[model].lon        
            
            DEF = read_data(var,timstat,model,\
                            path,meta.loc[model]['runs'],lat=lat,lon=lon)
            
            
            if var == 'treeFrac' and model in ['CESM','CESM2','MIROC','BCC','CNRM']:
                if model == 'BCC':
                    tx = 51
                elif model == 'MIROC':
                    tx = 150
                elif model == 'CNRM':
                    tx = 81
                else:
                    tx = 80 #meta.loc[model]['imax']
                dummy = DEF['treeFrac_'+meta.loc[model]['runs'][0]].isel(time=tx-1) -\
                        DEF['treeFrac_'+meta.loc[model]['runs'][0]].isel(time=0)
                dummy2 = np.repeat(np.expand_dims(dummy,2),tx,axis=2)
                CTL = xr.Dataset({'treeFrac_piControl': (('lon','lat','time'), dummy2)},
                        {'lon':DEF.lon, 'lat':DEF.lat, 'time': DEF.time })
            else:
                CTL = read_data(var,timstat,model,\
                            path, metaCTL.loc[model]['runs'],lat=lat,lon=lon)
            



            if model == 'CESM' and var == 'pr':
                DEF  = DEF * 86400
                CTL = CTL * 86400
#            if var == 'cLand':
            print 'SAVE DATA'
            file_out = open(path + 'DEF_'+model+'_'+var+'.obj','w')
            pickle.dump(DEF,  file_out)
            file_out.close() 
            file_out = open(path + 'CTL_'+model+'_'+var+'.obj','w')
            pickle.dump(CTL,  file_out)
            file_out.close()             
        else: 
            print 'LOAD DATA ' +  model
            file_out = path + 'DEF_'+model+'_'+var+'.obj'
            if os.path.isfile(file_out):
                DEF = pickle.load(open(file_out,'rb'))
            file_out = path + 'CTL_'+model+'_'+var+'.obj'
            if os.path.isfile(file_out):
                CTL = pickle.load(open(file_out,'rb'))    
                
            
        if SAVE_TS == True:         
            ### =================================================================
            ca = def_mask_regions[model][model+'_cellarea'] 
            weights = ca.copy(deep=True)/np.sum(ca)
    
            if var == 'treeFrac':
                DEF = DEF*ca.copy(deep=True)/10**14
                CTL = CTL*ca.copy(deep=True)/10**14 
    
            ### =====================================
            ### cut regions (box and deforest GD)
            ### =====================================
            DEF_reg = cutregions(DEF.copy(), var, meta.loc[model]['runs'],
                                 model, def_mask_regions, nregs=range(0,8))
            
            CTL_reg = cutregions(CTL.copy(), var, metaCTL.loc[model]['runs'],
                                 model, def_mask_regions, nregs=range(0,8))
    
    #        plt.pcolormesh(DEF_reg[model+'_tas_africa_r1i1p1f1'][:,:,79],cmap='Reds')
    #        plt.colorbar()
    #        plt.show()
    
            ### =====================================
            ### build field mean (CDOs?)
            ### =====================================    
    
            if 'GtC' in varinfo.loc[var]['unit']:
                DEF_ts = (DEF_reg*ca.copy(deep=True)).sum(dim=['lon','lat'],skipna=True)/10**12
                CTL_ts = (CTL_reg*ca.copy(deep=True)).sum(dim=['lon','lat'],skipna=True)/10**12        
            elif 'km' in varinfo.loc[var]['unit'] :
                DEF_ts = (DEF_reg).sum(dim=['lon','lat'],skipna=True)
                CTL_ts = (CTL_reg).sum(dim=['lon','lat'],skipna=True)
            else:
                DEF_ts = average_da(DEF_reg, dim=['lon','lat'],weights=weights)
                CTL_ts = average_da(CTL_reg, dim=['lon','lat'],weights=weights)
        
            DEF_ts = DEF_ts.copy(deep=True) #.isel(variable=0,drop=True)
            CTL_ts = CTL_ts.copy(deep=True) #.isel(variable=0,drop=True)
            
            
            
            
            
#            print DEF_ts[model+'_'+var+'_glob_r1i1p1f1']
#            print CTL_ts[model+'_'+var+'_glob_piControl']
            
#            
    #        print DEF_ts[model+'_treeFrac_glob_r1i1p1f1']
            
            if var == 'treeFrac' and model in ['CESM','CESM2','MIROC','BCC','CNRM']:
                ref_mean = DEF_ts.loc[dict(time='1850-12-31')]
                Diff_ts = calc_diff_ts(var, DEF_ts, ref_mean,\
                                   model,meta.loc[model]['runs'],nregs=range(0,8))
            else:
                ### select first xx years of CTL due to drifts in some models
                Diff_ts = calc_diff_ts(var, DEF_ts, 
                                       CTL_ts.isel(time=slice(0,varinfo.loc[var]['rw'])).mean(),
                                       model,
                                       meta.loc[model]['runs'],nregs=range(0,8))            
                
#            if model == 'CESM2' and var in ['cSoilSlow','fFire']:
#                print 'correct'
#                Diff_ts  = Diff_ts - Diff_ts.loc[dict(time='1850-12-31')]            
#            if model == 'BCC' and var in ['cLand','cSoilSlow','cSoilMedium']:
#                Diff_ts  = Diff_ts - Diff_ts.loc[dict(time='1850-12-31')]            
                
            
            ### =====================================
            ### Ensemblemean
            ### =====================================   
    
            CTL_ens = ensmean_reg(var,CTL_ts.copy(), model, nregs=range(0,8))
            DEF_ens = ensmean_reg(var,DEF_ts.copy(), model, nregs=range(0,8))
      
            ### =====================================
            ### Diff DEF-CTL
            ### =====================================
            ref_mean = None
            Diff_ens = DEF_ens - CTL_ens.isel(time=slice(0,varinfo.loc[var]['rw'])).mean()
            
            if var == 'pr':
                Diff_ens_rel = DEF_ens / CTL_ens.isel(time=slice(0,varinfo.loc[var]['rw'])).mean()
            
#            fig = plt.figure(figsize=(4*fig_scale,3*fig_scale))
#            Diff_ens['CESM2_cVeg_glob'].plot()
#            pngfile='/Users/lenaboysen/Google Drive/LUMIP/Time_series/cVeg_CESM_glob.png'
#            fig.savefig(pngfile,dpi=300, bbox_inches='tight')
#            plt.close()
            
            
            if var == 'treeFrac' and model in ['CESM','CESM2','MIROC','BCC','CNRM']:
                types = ['','GD']
                for rr in range(0,8):
                    for tt in [0,1]:
                        
                        ds = xr.Dataset({model+'_treeFrac'+types[tt]+regions[rr]:\
                                         DEF_ts[model+'_treeFrac'+types[tt]+\
                                                regions[rr]+'_'+meta.loc[model]['runs'][0]].loc[\
                                         dict(time='1850-12-31')].values})
                        if ref_mean is None: 
                            ref_mean = ds
                        else:
                            ref_mean = xr.merge([ref_mean,ds])    
                
                Diff_ens = DEF_ens - ref_mean
    
#            if model == 'CESM2' and var in ['cSoilSlow','fFire']:
#                Diff_ens  = Diff_ens - Diff_ens.loc[dict(time='1850-12-31')]
#                print 'correct'
#            if model == 'BCC' and var in ['cLand','cSoilSlow','cSoilMedium']:
#                Diff_ens  = Diff_ens - Diff_ens.loc[dict(time='1850-12-31')]                

                
            ### =====================================
            ### Running mean 
            ### =====================================
        
            Diff_ens_rm = Diff_ens.rolling(time = varinfo.loc[var]['rw'],center=True).mean()
            if varinfo.loc[var]['unit'] in ['GtC', 'GtC/'+timstat, 'Mkm2']:
    #            Diff_ens_rm2 = Diff_ens.copy(deep=True)
                Diff_ens_rm2 = Diff_ens.rolling(time = varinfo.loc[var]['rw'],center=True).mean()
            else:
                Diff_ens_rm2 = Diff_ens.rolling(time = varinfo.loc[var]['rw'],center=True).mean()
                if var == 'pr':
                    Diff_ens_rm2_rel = Diff_ens_rel.rolling(time = varinfo.loc[var]['rw'],center=True).mean()
                
            if Diff_out is None:
                Diff_out = xr.merge([Diff_ts, Diff_ens_rm2]) 
                if var == 'pr':
                    Diff_out_rel = Diff_ens_rm2_rel
            else:
                Diff_out = xr.merge([Diff_out, Diff_ts, Diff_ens_rm2])  
                if var == 'pr':
                    Diff_out_rel = xr.merge([Diff_out_rel, Diff_ens_rm2_rel])
                    
            print Diff_out[model+'_'+var+'_glob_'+meta.loc[model]['runs'][0]]
        
            print 'SAVE TS'
            file_out = open(path + 'TS_'+model+'_'+var+'.obj','w')
            pickle.dump(Diff_out,  file_out)
            file_out.close()
            
            if var == 'pr':
                file_out = open(path + 'TS_'+model+'_'+var+'_rel.obj','w')
                pickle.dump(Diff_out_rel,  file_out)
                file_out.close()             
        else:  ### load ts 
            print 'LOAD TS ' +  model
            file_out = path + 'TS_'+model+'_'+var+'.obj'
            if os.path.isfile(file_out):
                Diff_out = pickle.load(open(file_out,'rb'))
            

        
        if CALC_tTest == True:

            if var != 'treeFrac':
                
                ### ==================================================================
                #### ADJUST DATA FORMAT for t-test
                ### =============================================
                startyear = DEF['time'].dt.year.data[0]
                newtime = pd.date_range(str(startyear)+'-01-01', 
                                                 periods=varinfo.loc[var]['rw'], 
                                                 freq='Y')
                
                ### either 80 or metaCTL.loc[model]['imax']
                DEF_30 = DEF_ts.isel(time=slice(80-varinfo.loc[var]['rw'],80))
                DEF_30['time'] = newtime
                DEF_90 = shiftmergetime(DEF_30, variables[vv],meta.loc[model]['runs'], 
                                        dt=varinfo.loc[var]['rw']) 
                
                
                CTL_30 = CTL_ts.isel(time=slice(metaCTL.loc[model]['imax']-varinfo.loc[var]['rw'],
                                                metaCTL.loc[model]['imax']))
                
                if model == 'BCC':
                    CTL_30 = CTL_ts.isel(time=slice(0,varinfo.loc[var]['rw']))
                
                
                CTL_30['time'] = newtime
                
                CTL_90 = shiftmergetime(CTL_30.copy(deep=True), variables[vv],
                                metaCTL.loc[model]['runs'], dt= varinfo.loc[var]['rw'])
                    
                if len(meta.loc[model]['runs']) > 1:
                    ## at rw*len(runs) points
                    CTL_90 = CTL_90.isel(time=slice(0,varinfo.loc[var]['rw']*len(meta.loc[model]['runs']))) 
                else:
                    ## as amny as for DEF
                    CTL_90 = CTL_90.isel(time=slice(0,varinfo.loc[var]['rw'])) 

        
                var_mean = np.zeros(len(regions))
                sign = np.zeros(len(regions))
                pval = np.zeros(len(regions))
                ### =============================================
                ### modified t-Test (t-statistic = t^)
                ### =============================================
                
                for tt in range(0,2):
                    
                    for rr in range(0,8):    
                        
                        conf_level = 0.95
                    
                        xlen = len(CTL_90[model+'_'+variables[vv]+types[tt]+regions[rr]].time)
                        ylen = len(DEF_90[model+'_'+variables[vv]+types[tt]+regions[rr]].time)
                        x = CTL_90[model+'_'+variables[vv]+types[tt]\
                                   +regions[rr]].data.reshape((1,1,xlen))
                        y = DEF_90[model+'_'+variables[vv]+types[tt]\
                                   +regions[rr]].data.reshape((1,1,ylen))
                        
#                        if len(meta.loc[model]['runs']) > 1:
                        test3d = ttest.modTtest3d(x,y,
                                              alternative="two_sided",
                                              conf_level=conf_level) 
                    
                        pval[rr] = round(test3d['pvalue'][0][0],3)
#                        sign[rr] = pval[rr] >= conf_level
                        
                        sign[rr] = (pval[rr] >= 0.975) | (pval[rr]<0.025)
                        
#                        print 'PVAL for '+ model +' '+ variables[vv]+types[tt]+regions[rr] +':'+str(round(pval[rr],2))
                        

    #                    print variables[vv] +' diff = '+ str(np.round(var_mean[rr],2))+\
    #                                         ' pval = '+ str(round(pval,2))
                        sign_string = np.repeat(' ', np.shape(sign)[0])
                        sign_string[ sign == 1 ] = '*'
                   
                    
                        var_mean[rr]= y.mean(axis=2) - x.mean(axis=2) 
                    
#                    if len(meta.loc[model]['runs']) > 1:
                    var_string = map(( lambda x: str(np.around(var_mean[x],3)) + \
                                      sign_string[x] + ' ('+str(pval[x])+')'),
                                 range(0,np.shape(sign)[0]) )
#                    else:
#                        var_string = np.around(var_mean,3)
                        
                        
                        
                    df_new = pd.DataFrame({
                        model+'_'+variables[vv]+types[tt]: var_string,
                        'regions': regions} ).set_index('regions')  
                            
                    if df_table is None:
                        df_table = df_new
                    else:
                        df_table = pd.concat([df_table,df_new],axis=1)
                            
                df_table.to_excel('/Users/lenaboysen/Google Drive/LUMIP/Values/Values_'+\
                              variables[vv]+'.xls') #_'+model+'
                                    