
#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 16 15:50:15 2018

@author: lenaboysen

CREATE Deforestation mask and fractions based on treeFrac or additional files

Data needed: LUMIP_MAP_read_save_data.py

"""


import os
import numpy as np
np.set_printoptions(threshold=100) # 'nan'
import os.path
import sys as sys
import pickle

#import cdo
#cdo = cdo.Cdo()
#cdo.setCdo('/opt/local/bin/cdo')
import xarray as xr
#from matplotlib import gridspec
from datetime import datetime, date


#plot
import matplotlib.pyplot as plt
import matplotlib as mpl
import matplotlib.colors as colors
import seaborn as sns; sns.set(color_codes=True)

#import plotly.plotly as py
#import plotly.graph_objs as go
import pandas as pd


new_path = '/Users/lenaboysen/Google Drive/python/'
if new_path not in sys.path:
    sys.path.append(new_path)
    
#% Constants
kg_C_per_kg_CO2 = 0.272918
kg_C_perMol = 0.012011
C_to_K = 273.15
MPa_to_mm = 1022.8

#%% FUNCTIONS

def read_data(var,timstat,model,path,runs,lat=None,lon=None,calc_deffrac=False):
#    var = ['treeFrac']
#    timstat = 'year'
#    path = "/Users/lenaboysen/mistral/LUMIP/EC/"
#    length = 1
#    vv = 0;
#    runs = ['r1i1p1f1']
#    rr = 'r1i1p1f1'
#    
    if type(var) == str:
        length = 1
        var = [var]
    elif type(var) == list:
        length = np.shape(var)[0]
        
    ds_data = None
    for vv in range(0,length):       
        for rr in runs: 
            
#            print 'read in exp = '+ model+ ' '+ rr + ' ' + ' '+ var[vv]
            print path + rr +'/'+var[vv]+'_'+model+'_'+timstat+'.nc'
            
            if model == 'EC' and var[vv] == 'deforested':
                ds_new = xr.open_dataset(path + rr +'/'\
                                         +'lut_diff.nc',\
                                         cache=False, decode_times=False)
            else:
                ds_new = xr.open_dataset(path + rr +'/'\
                                         +var[vv]+'_'+model+'_'+timstat+'.nc',\
                                         cache=False, decode_times=False)
            ds_new.close()
    
#            print ds_new[var[vv]].shape # dsA.cveg.coords, dsA.cveg.dims, dsA.info
            ### Data must be in shape  lon, lat, time!!
            if var[vv] != 'cellarea':
#                if (model in ['EC']) and (rr == 'r1i1p1f1'):
#                    ds_new = ds_new.sel(bnds=0)                
                
                nt = np.shape(ds_new['time'])[0]
                if timstat == 'year':
                    ff = 'y'
                else:
                    ff = 'm'
                    
                if lat is None and (rr == runs[0] or rr == 'piControl'):
                    lat = ds_new['lat'].values
                if lon is None and (rr == runs[0] or rr == 'piControl'):
                    lon = ds_new['lon'].values 
                    
                    
                ### comment out if def_mask_regions is only created now!   
                if model in ['CESM2','CNRM'] and calc_deffrac == False:
                    lat = def_mask_regions[model][model+'_deffrac_glob'].lat
#                if model == 'MIROC' and calc_deffrac == False:
#                    lat = lat[::-1]              
                
                if model == 'EC' and var[vv] != 'deforested':
                    nt = nt-1
                    ds_new = ds_new.isel(time=slice(1,len(ds_new.time)))
                    
                startyear = 1850
                time = pd.date_range(str(startyear)+'-01-01', periods=nt, freq=ff)
                ds_new2 = xr.Dataset({var[vv]:(('time', 'lat', 'lon'),ds_new[var[vv]])},
                                     {'time': time,
                                      'lat':lat, #ds_new['lat'],
                                      'lon':lon}) # ds_new['lon']})
                ds_new2 = ds_new2.transpose('lon','lat','time')
    
                if ds_data is None:
                    ds_data = xr.Dataset({var[vv]+'_'+rr:ds_new2[var[vv]]})
                else:
                    ds_new3 = xr.Dataset({var[vv]+'_'+rr:ds_new2[var[vv]]})
                    ds_data = xr.merge([ds_data,ds_new3])
                    del ds_new3
            else:
                if ds_data is None:
                    ds_data = xr.Dataset({var[vv]+'_'+rr: 
                                        (('lon','lat'),ds_new[var[vv]].transpose('lon','lat'))},
                                          {'lon':lon, 'lat': lat})
                else:
                    ds_new3 = xr.Dataset({var[vv]+'_'+rr: 
                                        (('lon','lat'),ds_new[var[vv]].transpose('lon','lat'))},
                                          {'lon':lon, 'lat': lat})
                    ds_data = xr.merge([ds_data,ds_new3])
                    del ds_new3
            
            
#        print ds_data
    return(ds_data)


def create_defmask(CTL, DEF, maskvar, cutoff = 0.001):
    ### 1. select keys containing vars, ensmean over them
    ### 2. mean over last 10 years of DEF and CTL
#    DEF = DEF
#    CTL = CTL
#    maskvar = maskvar[0]
    
    
    ### Some models do not have treeFrac in piControl
    if type(maskvar) == str:
        maskvar = [maskvar]
    if model in ['BCC','MIROC']:
        DEF_mean = DEF.loc[dict(time='1900-12-31')]
        CTL_mean = CTL.loc[dict(time='1900-12-31')]
        
    elif model in ['UKESM']:
        DEF_mean = DEF.loc[dict(time='1900-12-31')]
        CTL_mean = CTL.loc[\
                dict(time=slice('1920-01-01','1929-12-31'))].mean('time') 
    elif model in ['EC']:
        DEF_mean = DEF.loc[dict(time='1901-12-31')]
        CTL_mean = CTL.loc[\
                dict(time=slice('1850-01-01','1859-12-31'))].mean('time') 
    else:    
        DEF_mean = DEF.loc[\
                dict(time=slice('1920-01-01','1929-12-31'))].mean('time')
        CTL_mean = CTL.loc[\
                dict(time=slice('1850-01-01','1859-12-31'))].mean('time')

    DEF_ensmean = ensmean(maskvar, DEF_mean)
    CTL_ensmean = ensmean(maskvar, CTL_mean)
    
    cf = CTL_ensmean['treeFrac'].values/100
    
    ### Some models do not have treeFrac in piControl
    if model in ['CESM2','BCC','MIROC','CNRM']:
        diff = (DEF_ensmean['treeFrac'] -\
                DEF['treeFrac_'+meta.loc[model]['runs'][0]].loc[dict(time='1850-12-31')].rename(\
                        {'treeFrac'})).values 
                
#    elif model in ['EC']:
#        diff = (DEF_ensmean['treeFrac'] -\
#                DEF['treeFrac_'+meta.loc[model]['runs'][0]].loc[dict(time='1850-12-31')].rename(\
#                        {'treeFrac'})).values         
#    elif model == 'BCC':
#        diff = (DEF['treeFrac_r1i1p1f1'].loc[dict(time='1930-12-31')].rename(\
#                        {'treeFrac'})).values -\
#                (DEF['treeFrac_r1i1p1f1'].loc[dict(time='1850-12-31')].rename(\
#                        {'treeFrac'})).values
                       
    else:
        diff = (DEF_ensmean - CTL_ensmean)['treeFrac'].values 
        
    if model == 'EC':
#        diff = np.where(diff > 0, 0 ,diff)
        diff = np.where(lut['deforested'] > 0, 0, diff)
        
    def_mask = np.zeros(np.shape(diff))
    diff_helper = np.copy(diff)
    diff_helper[np.isnan(diff)] = 0
    
    print 'cutoff =' + str(cutoff)
    
    def_mask[ diff_helper < -cutoff ] = 1
    def_mask[ diff_helper >= -cutoff ] =  0  # np.nan
    
    print 'here3'
    plt.pcolormesh(def_mask)
    plt.colorbar()
    plt.show()
    print 'here3'    
    return cf, diff, def_mask


def create_defmask_t(CTL, DEF, maskvar, cutoff = 0.001):
    ### 1. select keys containing vars, ensmean over them
    ### 2. mean over last 10 years of DEF and CTL
#    DEF = DEF
#    CTL = CTL
#    cutoff = 0.001
#    maskvar = maskvar[0]
    
    if type(maskvar) == str:
        maskvar = [maskvar]
    if model in ['BCC','MIROC']:
        CTL_mean = CTL.loc[dict(time='1900-12-31')]
    else:    
        CTL_mean = CTL.loc[\
                dict(time=slice('1850-01-01','1859-12-31'))].mean('time')
    
    DEF_ensmean = ensmean(maskvar, DEF)
    CTL_ensmean = ensmean(maskvar, CTL_mean)
    
    if model in ['CESM2','BCC','MIROC','CNRM']:
        diff = (DEF_ensmean['treeFrac'] -\
                DEF['treeFrac_'+meta.loc[model]['runs'][0]].loc[dict(time='1850-12-31')].rename(\
                        {'treeFrac'})).values 
#    elif model in ['EC']:
#        diff = (DEF_ensmean['treeFrac'] -\
#                DEF['treeFrac_'+meta.loc[model]['runs'][0]].loc[dict(time='1850-12-31')].rename(\
#                        {'treeFrac'})).values    
           
#    elif model == 'BCC':
#        diff = (DEF['treeFrac_r1i1p1f1'].loc[dict(time='1930-12-31')].rename(\
#                        {'treeFrac'})).values -\
#                (DEF['treeFrac_r1i1p1f1'].loc[dict(time='1850-12-31')].rename(\
#                        {'treeFrac'})).values
                       
    else:
        diff = (DEF_ensmean - CTL_ensmean)['treeFrac'].values 
    
    if model == 'EC':
#        diff = np.where(diff > 0, 0 ,diff)
#        diff = np.where(lut['deforested'] > 0, 0, diff)
#        diff = np.ma.masked_array(diff,lut>0)


        lut2 = lut.expand_dims({'time'})
        other = xr.DataArray(np.ones(len(DEF.time)), coords=[('time', range(0,len(DEF.time)))])
        mask = xr.broadcast(lut2['deforested'], other) 
        diff = np.ma.masked_array(diff,mask>0)
        
        
   
    
    
    
    

#    print 'here3'
#    plt.pcolormesh(diff[:,:,10])
#    plt.colorbar()
#    plt.show()
#    print 'here3'    
    return diff



def ensmean(variables, data):
#    variables = maskvar
#    data = DEF_mean
    
    data_ensmean = None
    for vv in variables:
        items = [s for s in data.keys() if vv in s]
        data_mean2 = data[items].to_array().mean(axis=0).to_dataset(name=vv)
        if data_ensmean is None:
            data_ensmean = data_mean2
        else: 
            data_ensmean = xr.merge([data_ensmean,data_mean2])
    return data_ensmean




def create_defmask_regions(cf, diff, def_mask, model, lon, lat):


    regions_lonlat = xr.Dataset({'_glob':([lon[0],lon[len(lon)-1],
                                           lat[0],lat[len(lat)-1]]),
                                 '_soam':([250,330,-60,25]),                             
                                 '_africa':([340,360,-45,36]),
                                 '_africa2':([0,43,-40,36]),                             
                                 '_sea_aust':([45,180,-48,37]),                             
                                 '_noam_temp':([230,330,26,50]),                             
                                 '_noam_bor':([190,329,50,80]),                             
                                 '_eura_bor':([0,180,60,80]), 
                                 '_eura_bor2':([330,360,60,80]),                              
                                 '_eura_temp':([0,160,36,60]),
                                 '_eura_temp2':([350,360,36,60])})

    
    def_mask_regions = xr.Dataset()
    for rr in range(0,8):
        print regions[rr]
        def_mask2 = def_mask.copy()
        diff2 = diff.copy()
        cf2 = cf.copy()
        
        
    #    newmask = np.ones((len(lon),len(lat))) ## ones are masked out
        if rr == 0:
            newmask = xr.Dataset({'region':(('lon','lat'),
                                np.zeros((len(lon),len(lat))))},
                                {'lat': lat, 'lon': lon})
        else:
            newmask = xr.Dataset({'region':(('lon','lat'),
                                            np.ones((len(lon),len(lat))))},
                                {'lat': lat, 'lon': lon})
            newmask['region'].loc[dict(
                    lon=slice(regions_lonlat[regions[rr]].values[0],
                    regions_lonlat[regions[rr]].values[1]),
                    lat=slice(regions_lonlat[regions[rr]].values[2],
                    regions_lonlat[regions[rr]].values[3]))] = 0 
    
            if regions[rr] == '_africa':
                newmask['region'].loc[dict(
                    lon=slice(regions_lonlat['_africa2'].values[0],
                              regions_lonlat['_africa2'].values[1]),
                    lat=slice(regions_lonlat['_africa2'].values[2],
                              regions_lonlat['_africa2'].values[3]))] = 0 
            if regions[rr] == '_eura_temp':
                newmask['region'].loc[dict(
                    lon=slice(regions_lonlat['_eura_temp2'].values[0],
                              regions_lonlat['_eura_temp2'].values[1]),
                    lat=slice(regions_lonlat['_eura_temp2'].values[2],
                              regions_lonlat['_eura_temp2'].values[3]))] = 0                       
            if regions[rr] == '_eura_bor':
                newmask['region'].loc[dict(
                    lon=slice(regions_lonlat['_eura_bor2'].values[0],
                              regions_lonlat['_eura_bor2'].values[1]),
                    lat=slice(regions_lonlat['_eura_bor2'].values[2],
                              regions_lonlat['_eura_bor2'].values[3]))] = 0                                                
#        plt.pcolormesh(newmask['region'].values,cmap='RdBu')
#        plt.colorbar()
#        plt.show()
        newmask = newmask['region'].values
        
        ## regions: lonlat boxes
        ## deffrac: only deforestation area of lonlatbox
        ## cf: cover fractions CTL
        dummy = xr.Dataset({model +regions[rr]: (('lon','lat'), newmask),
                            model +'_defmask'+regions[rr]: (('lon','lat'),
                                             np.ma.masked_array(def_mask2, newmask)),
                            model +'_deffrac'+regions[rr]: (('lon','lat'),
                                             np.ma.masked_array(diff2, newmask)),
                            model +'_cf'+regions[rr]: (('lon','lat'),
                                        np.ma.masked_array(cf2, newmask))},
                                            {'lon': lon, 'lat': lat})
    
        if rr == 0:
            def_mask_regions = dummy
        else:
            old = def_mask_regions
            def_mask_regions = xr.merge([old, dummy])
            
    return def_mask_regions



def ensmean_reg(variables,data,model,nregs=range(0,8)):
#    variables = [var]
#    data = CTL_ts
    if type(variables) == str:
        variables = [variables]    
    data_ensmean = None   
    for vv in variables:
        itemsV = [s for s in data.keys() if vv in s]
        for rr in nregs:
            itemsR = [s for s in itemsV if regions[rr] in s]
            for tt in ['', 'GD']:
                itemsGD = [s for s in itemsR if vv+tt+regions[rr] in s]
        
                data_mean2 = data[itemsGD].to_array().mean(axis=0).to_dataset(
                        name=model+'_'+vv+tt+regions[rr])
                
                if data_ensmean is None:
                    data_ensmean = data_mean2
                else: 
                    data_ensmean = xr.merge([data_ensmean,data_mean2])
    return data_ensmean



def shiftmergetime(ds, var, runs, dt):
#    ds = CTL_30.copy()
#    dt = 30
#    var = 'tas'
#    
    firstyear = ds['time'].dt.year.data[0]
    ds_out = None
    ## all keys with variable
    itemsV = [s for s in ds.keys() if var in s] 
        ## thereof all keys with region 
    for rr in range(0,8):
        itemsR = [s for s in itemsV if regions[rr] in s]

        for typ in [var+regions[rr],var+'GD'+regions[rr]]:
            itemsT = [s for s in itemsR if typ in s]
            ds_new = None; 
            j = 0
            for i in itemsT:
                if ds_new is None:
                    ds_new = ds[i]
                    j = j + 1
                else: 
#                    if len(runs)>5:
#                        firstyear = firstyear - dt*len(runs)/2
                    time = pd.date_range(str(firstyear)+'-01-01', 
                                         periods=dt, 
                                         freq='Y').shift(dt*j,freq='Y')
                    ds2 = ds[i]
                    ds2['time'] = time
                    ds_new = xr.concat([ds_new,ds2],dim='time')
                    j = j + 1
                    
             
                ds_new3 = xr.Dataset({model+'_'+typ:(('time'), ds_new.values)},
                                  {'time': ds_new['time']})        
                if ds_out is None:  
                    ds_out = ds_new3
                else:
                    ds_out = xr.merge([ds_out, ds_new3])
                
    return ds_out



def myround(x, base=0.5):
        return round(base*round(x/base), 2)        


def cutregions(data_var, var, runs, model, def_mask_regions, nregs=range(0,8)):
#    data_var = DEF.copy()
#    var = ['tas']
#    nregs=range(0,7)
#    runs = meta.loc[model]['runs']
#    def_mask_regions = def_mask_regions
#    model = model
    lat = data_var.lat.values
    lon = data_var.lon.values
    
    if type(var) == str:
        length = 1
        var = [var]
    elif type(var) == list:
        length = np.shape(var)[0]
    
    data_out = None
    for vv in range(0,length):
        
        items = [s for s in data_var.keys() if var[vv] in s]
        data_time = data_var[items[0]]['time']
        data_t = len(data_time)
        
        for rr in nregs:
            data = data_var[items].copy(deep=True)
         
            for run in runs:
                print var[vv] + ' ' + regions_names[rr] + ' ' + run
                
                regmask = def_mask_regions[model][
                            model + regions[rr]].copy(deep=True)
                regmask2 = xr.where(regmask > 0, 1, 0)

                def_regmask = def_mask_regions[model][
                            model+'_defmask'+regions[rr]].copy(deep=True)
                def_regmask2 = xr.where(def_regmask > 0, 0, 1)               
                                                
                regions_t = np.repeat(np.expand_dims(
                                regmask2.copy(deep=True),2),data_t,axis=2)
                regions_def_t = np.repeat(np.expand_dims(
                                def_regmask2.copy(deep=True),2),data_t,axis=2)

                if rr > 0:
                    data_regbox = np.ma.masked_array(
                            data[var[vv]+'_'+run].copy(deep=True),regions_t)
                    data_regdef = np.ma.masked_array(
                            data[var[vv]+'_'+run].copy(deep=True),regions_def_t)
                else:
                    data_regbox = data[var[vv]+'_'+run].copy(deep=True)
                    data_regdef = np.ma.masked_array(
                            data[var[vv]+'_'+run].copy(deep=True),regions_def_t)

                ds1 =  xr.Dataset({model+'_'+var[vv]+regions[rr]+'_'+run: 
                                            (('lon','lat','time'),data_regbox),
                                   model+'_'+var[vv]+'GD'+regions[rr]+'_'+run:
                                            (('lon','lat','time'),data_regdef)},
                                        {'lon': lon, 'lat': lat,'time': data_time})                                
                if data_out is None:
                    data_out = ds1
                else:
                    old = data_out
                    data_out = xr.merge([old, ds1])
    return(data_out)



    
def average_ds(self, dim=None, weights=None):
    if weights is None:
        return self.mean(dim)
    else:
        return self.apply(average_ds, dim=dim, weights=weights)



#DEF_reg, dim=['lon','lat'],weights=weights
def average_da(self, dim=None, weights=None):
#    self = DEF_reg #_IPSL
#    weights = weights #_IPSL
#    dim=['lon','lat']
#    
    if weights is None:
        return self.mean(dim)
    else:
        if not isinstance(weights, xr.DataArray):
            raise ValueError("weights must be a DataArray")

        # if NaNs are present, we need individual weights
        if self.notnull().any():
            total_weights = weights.where(self.notnull()).sum(dim=dim)
        else:
            total_weights = weights.sum(dim)

        average_da = (self * weights).sum(dim) / total_weights
        return average_da


def calc_diff_ts(var, DEF_ts, CTL_ts_mean, model,runs,nregs=range(0,8)):
    if type(var) == str:
        var = [var]
    
    ds_out = None
    time = DEF_ts.time
    for vv in var:
        for rr in nregs:
            for typ in [vv+regions[rr], vv+'GD'+regions[rr]]:
                for run in runs:
                    if model in ['CESM2','BCC','MIROC','CNRM','EC'] and vv == 'treeFrac':
                        diff = DEF_ts[model+'_'+typ+'_'+run] -  \
                           CTL_ts_mean[model+'_'+typ+'_'+meta.loc[model]['runs'][0]]
                    else:
                        diff = DEF_ts[model+'_'+typ+'_'+run] -  \
                           CTL_ts_mean[model+'_'+typ+'_piControl']
                    
                    ds = xr.Dataset({model+'_'+typ+'_'+run:(('time'),diff)},
                                         {'time':time})
                    if ds_out is None:
                        ds_out = ds
                    else:
                        ds_out = xr.merge([ds_out, ds])
    return ds_out
                                


#%%  DEFINE VARIABLES
mistral = False
        
regions = ['_glob','_soam','_africa','_sea_aust','_noam_temp','_noam_bor','_eura_bor','_eura_temp']
regions_names = ['Global','South America','Africa','SE Asia & Aust.','North Am. temp.','North Am. bor.','Eurasia bor.','Eurasia temp.']

models = ['MPI','IPSL','CESM2','Can','CNRM','BCC','MIROC','UKESM','EC']
models_name = pd.DataFrame({'IPSL': ['IPSL-CM6A-LR'],
                            'MPI': ['MPI-ESM-1.2.0'],
                             'CESM2': ['CESM2'],
                             'Can': ['CanESM5'],
                             'CNRM': ['CNRM-ESM2-1'],
                             'BCC': ['BCC-CSM2-MR'],
                             'MIROC': ['MIROC-ES2L'],
                             'UKESM':['UKESM1-0-LL'],
                             'EC':['EC-Earth3-Veg']})


timstat = 'year'

meta = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                              'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[150, 80,  80, 90, 80, 81,150, 80, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90,90,90, 90],
                     'nruns':[7,3, 3, 2, 1, 1, 1, 1, 1],
                     'runs': [['r1i1p1f1','r2i1p1f1','r3i1p1f1','r4i1p1f1',\
                               'r5i1p1f1','r6i1p1f1','r7i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p2f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1']]\
                               }).set_index('model')
    
metaCTL = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                                 'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[150, 80,  80, 90, 80, 81, 90, 90, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90, 90, 90, 90],
                     'nruns':[ 7, 3, 1, 2, 1, 1, 1, 1, 1],
                     'runs': [['piControl'],
                              ['piControl'],
                              ['piControl'],\
                              ['piControl'],\
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl']]}).set_index('model')

## index = rownames; select with meta.loc['IPSL']    
cols = pd.DataFrame({'IPSL': ['orchid','purple'],
                             'CESM': ['orchid','orchid'],
                              'MPI': ['indianred','indianred'],
                              'CESM2':['dodgerblue','dodgerblue'],
                              'Can': ['orange','orange'],
                              'BCC': ['navy','navy'],
                              'CNRM' : ['seagreen','seagreen'],
                              'MIROC' : ['gray','gray'],
                              'UKESM': ['pink','pink'],
                              'EC':['cornflowerblue','cornflowerblue']})
                    

#%%               
SAVE_defmask = True 

if mistral == True:
    savepath = "/Users/lenaboysen/mistral/LUMIP/"  
else:
    savepath = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"
        

#savepath = "/Users/lenaboysen/mistral/LUMIP/"   
##----------------------------------------------------
if SAVE_defmask == True:                    
# Read in mask of deforestation --> Overlay maps with contour
    def_mask_regions = {}
    diff_t = {}
    for model in models:
        print model
        ### =============================================
        #### Create DEFORESTATION MASK
        ### =============================================

        
        if mistral == True:
            path="/Users/lenaboysen/mistral/LUMIP/"+model+"/"
        else:
            path = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"+model+"/"
        
        maskvar = ['treeFrac','cellarea'] #,'grassFrac']            
        DEF = read_data(maskvar, timstat, model,\
                    path, meta.loc[model]['runs'], calc_deffrac = True)

        if model == 'EC':
            lut = read_data('deforested', timstat, model,\
                    path, meta.loc[model]['runs'], calc_deffrac = True)
            lut = lut.rename({'deforested_r1i1p1f1':'deforested'}).isel(time=0)
        
        
        if model in ['CESM2','BCC','MIROC','CNRM']:
            if model == 'BCC':
                tx = 51
            elif model == 'MIROC':
                tx = 150
            elif model == 'CNRM':
                tx = 81
            else:
                tx = 80 #meta.loc[model]['imax']

                
            dummy = DEF['treeFrac_'+meta.loc[model]['runs'][0]].isel(time=tx-1) -\
                    DEF['treeFrac_'+meta.loc[model]['runs'][0]].isel(time=0)
            dummy2 = np.repeat(np.expand_dims(dummy,2),tx,axis=2)
            CTL1 = xr.Dataset({'treeFrac_'+meta.loc[model]['runs'][0]: \
                                           (('lon','lat','time'), dummy2)},
                        {'lon':DEF.lon, 'lat':DEF.lat, 'time': DEF.time })
            CTL = xr.merge([CTL1 , DEF['cellarea_'+meta.loc[model]['runs'][0]]])
            
            print 'here'
            plt.pcolormesh(CTL['treeFrac_'+meta.loc[model]['runs'][0]].isel(time=49))
            plt.colorbar()
            plt.show()  
            print 'here'
   
        else:    
            CTL = read_data(maskvar,timstat,model,\
                        path, metaCTL.loc[model]['runs'])
        
        if model == 'EC':
            cutoff = 10
            CTL['lat'] = DEF['lat']
        else:
            cutoff = 0.001
        
        cf, diff, def_mask = create_defmask(CTL, DEF, maskvar[0], cutoff = cutoff)   
            
        diff_t[model] = xr.Dataset({'diff_t': (('lon','lat','time'), 
                          create_defmask_t(CTL, DEF, maskvar[0], cutoff = cutoff) )},
                        {'lon':DEF.lon, 'lat':DEF.lat, 'time': DEF.time })
        
        def_mask_regions[model] = create_defmask_regions(cf, diff, def_mask, model, 
                                            CTL.lon.values, CTL.lat.values)
        def_mask_regions[model][model+'_cellarea'] = DEF['cellarea_'+meta.loc[model]['runs'][0]]

        plt.pcolormesh(diff)
        plt.colorbar()
        plt.show()    
        
        plt.pcolormesh(def_mask)
        plt.colorbar()
        plt.show()    
        
        dim=['lon','lat']
        ca = def_mask_regions[model][model+'_cellarea']
        weights = ca.copy(deep=True)/np.sum(ca)
        
        if model in ['CESM2','BCC','CNRM']:
            init_forest = DEF['treeFrac_'+meta.loc[model]['runs'][0]].isel(time=0).to_dataset(name='treeFrac')
            print 'initial forest '+ str((init_forest['treeFrac']/100*ca).sum(dim)/1e12)
        elif model == 'MIROC':
            init_forest = xr.open_dataset(path + '/'+metaCTL.loc[model]['runs'][0]+'/'\
                                     +'treeFrac'+'_'+model+'_'+timstat+'.nc',\
                                     cache=False, 
                                     decode_times=False).rename({'sftlf':'treeFrac'})
            print 'initial forest '+ str((init_forest['treeFrac'].T/100*ca).sum(dim)/1e12)
            
#            plt.pcolormesh(init_forest['treeFrac'].T)
#            plt.colorbar()
#            plt.show()              
        else:
            init_forest = CTL['treeFrac_piControl'].isel(time=0).to_dataset(name='treeFrac')
            print 'initial forest '+ str((init_forest['treeFrac']/100*ca).sum(dim)/1e12)
        
        if model == 'MIROC':
            def_mask_regions[model][model+'_init_forest'] = -init_forest['treeFrac'].T
        else:
            def_mask_regions[model][model+'_init_forest'] = init_forest['treeFrac']     
            
        area = round((diff/100 * ca ).sum(dim)/1e12,2) 
        print 'defarea = ' + str(area) + ' Mkm2'  
        print 'min frac '+ str(np.nanmin(diff))
        
        
        ### save as netCDF
#        def_mask_regions[model][model+'_deffrac_glob'].to_netcdf(savepath+model+'_def_mask_regions.nc','w')
#        def_mask_regions[model][model+'_cellarea'].to_netcdf(savepath+model+'_cellarea.nc','w')
    
    file_out = open(savepath + 'def_mask_regions.obj','w')
    pickle.dump(def_mask_regions, file_out)
    file_out.close() 
    
    file_out = open(savepath + 'deffrac_TS_regions.obj','w')
    pickle.dump(diff_t, file_out)
    file_out.close()     
    
    
else: 
    file_out = savepath + 'def_mask_regions.obj'
    if os.path.isfile(file_out):
        def_mask_regions = pickle.load(open(file_out,'rb'))
        
    file_out = savepath + 'deffrac_TS_regions.obj'
    if os.path.isfile(file_out):
        diff_t = pickle.load(open(file_out,'rb'))    
        
        