#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Thu May 28 08:33:12 2020

@author: lenaboysen


PLOT MAPS with stat significance testing


Data needed: LUMIP_MAP_read_save_data.py

"""



import os
import numpy as np
np.set_printoptions(threshold=100) # 'nan'
#import os.path
import sys as sys
import pickle

#import cdo
#cdo = cdo.Cdo()
#cdo.setCdo('/opt/local/bin/cdo')
import xarray as xr
#from matplotlib import gridspec
#from datetime import datetime, date, time, timedelta

#plot
import matplotlib.pyplot as plt
import matplotlib as mpl
import matplotlib.colors as colors
import seaborn as sns; sns.set(color_codes=True)
import cartopy.crs as ccrs

#import plotly.plotly as py
#import plotly.graph_objs as go
import pandas as pd



new_path = '/Users/lenaboysen/Google Drive/python/'
if new_path not in sys.path:
    sys.path.append(new_path)
    
#from mod_tTest import *
import mod_tTest as ttest
import zerodivcolormap as zcmap
 
## Constants
kg_C_per_kg_CO2 = 0.272918
kg_C_perMol = 0.012011
C_to_K = 273.15
MPa_to_mm = 1022.8

#%% FUNCTIONS

def whitelinefix(lons):
    return np.append(lons,360)

            
def myround(x, base=0.5):
        return round(base*round(x/base), 2)        



def create_colorbar(var_min, var_max):        
    if np.abs(np.abs(var_max) + np.abs(var_min))  <= 0.05:
        inc = 0.005    
    elif np.abs(np.abs(var_max) + np.abs(var_min))  <= 0.15:
        inc = 0.01     
    elif np.abs(np.abs(var_max) + np.abs(var_min))  <= 0.5:
        inc = 0.05                  
    elif np.abs(np.abs(var_max) + np.abs(var_min))  <= 2.0:
        inc = 0.2
    elif 2 < np.abs(np.abs(var_max) + np.abs(var_min)) <= 5:
        inc = 0.5  
    elif 5 < np.abs(np.abs(var_max) + np.abs(var_min)) <= 10:
        inc = 1.0
    elif 10 < np.abs(np.abs(var_max) + np.abs(var_min)) <= 20:
        inc = 2      
    elif 20 < np.abs(np.abs(var_max) + np.abs(var_min)) <= 50:
        inc = 5.0   
    elif 10 < np.abs(np.abs(var_max) + np.abs(var_min)) <= 100:
        inc = 10.0
    elif 10 < np.abs(np.abs(var_max) + np.abs(var_min)) <= 500:
        inc = 50.0      
    elif 10 < np.abs(np.abs(var_max) + np.abs(var_min)) <= 1000:
        inc = 100.0            
    elif 10 < np.abs(np.abs(var_max) + np.abs(var_min)) <= 2000:
        inc = 250.0                   
    
    var_min = - myround(np.nanmax([np.abs(var_min),np.abs(var_max)]),base=inc/2)   
    var_max = myround(np.nanmax([np.abs(var_min),np.abs(var_max)]),base=inc/2)
    
    var_min = var_min - inc
    var_max = var_max + inc
    
    print 'RANGE = '+ str(np.abs(np.abs(var_max) + np.abs(var_min)) )
    
        
    ### --- COLORBAR SPECIFICATIONS ----*
    cmap = plt.cm.get_cmap('RdBu_r')
    cmap.set_under('w')
    
    # extract all colors from the .jet map
    cmaplist = [cmap(i) for i in range(cmap.N)]
    #    # force the last color entry to be white
#    cmaplist[np.shape(cmaplist)[0]-1] = (0.6,0.6,0.6,1.0)
#    cmaplist[0] = (0.3,0.3,0.3,1.0)
    
    # create the new map
    cmap = cmap.from_list('Custom cmap', cmaplist, cmap.N)
    
    if var[vv] == 'pr':
        cmap = plt.cm.get_cmap('BrBG')
        cmap.set_under('w')
        cmaplist = [cmap(i) for i in range(cmap.N)]
        cmap = cmap.from_list('Custom cmap', cmaplist, cmap.N)
    
    def myroundround(x,base=0.5):
                return(round(2*base*round(x/base), 2))
                
    tckspos = np.arange(inc,myround(np.nanmax([np.abs(var_min),np.abs(var_max)]),inc)+inc,
                                inc)
    tcksneg = -tckspos[::-1]
    tcks = list(tcksneg) + [-inc/10., inc/10.] + list(tckspos)
           
    norm = mpl.colors.BoundaryNorm(tcks, cmap.N)
    
    return cmap, tcks, norm



#%%  DEFINE VARIABLES
mistral = False        

regions = ['_glob','_soam','_africa','_sea_aust','_noam_temp','_noam_bor','_eura_bor','_eura_temp']
regions_names = ['Global','South America','Africa','SE Asia & Aust.','North Am. temp.','North Am. bor.','Eurasia bor.','Eurasia temp.']

models = ['MPI','IPSL','CESM2','Can','CNRM','BCC','MIROC','UKESM','EC']
models_name = pd.DataFrame({'IPSL': ['IPSL-CM6A-LR'],
                            'MPI': ['MPI-ESM-1.2.0'],
                             'CESM2': ['CESM2'],
                             'Can': ['CanESM5'],
                             'CNRM': ['CNRM-ESM2-1'],
                             'BCC': ['BCC-CSM2-MR'],
                             'MIROC': ['MIROC-ES2L'],
                             'UKESM':['UKESM1-0-LL'],
                             'EC':['EC-Earth3-Veg']})


timstat = 'year'

meta = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                              'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[150, 80,  80, 90, 80, 81,150, 80, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90,90,90, 90],
                     'nruns':[7,3, 3, 2, 1, 1, 1, 1, 1],
                     'runs': [['r1i1p1f1','r2i1p1f1','r3i1p1f1','r4i1p1f1',\
                               'r5i1p1f1','r6i1p1f1','r7i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p2f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1']]\
                               }).set_index('model')
    
metaCTL = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                                 'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[150, 80,  80, 90, 80, 81, 90, 90, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90, 90, 90, 90],
                     'nruns':[ 7, 3, 1, 2, 1, 1, 1, 1, 1],
                     'runs': [['piControl'],
                              ['piControl'],
                              ['piControl'],\
                              ['piControl'],\
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl']]}).set_index('model')
cexx = 10
cexx2 = 12    

#%%    
### =============================================
#### READ in VARIABLES 
### =============================================
rr = 0
timstat = 'year'
typ = '_'

varinfo = pd.DataFrame({'var':['tas',
                               'pr',
                               'gpp',
                               'cLand',
                               'cVeg','cSoil','cLitter',
                               'cSoilFast','cSoilSlow','cSoilMedium',
                               'evspsbl','npp','rh','nep','fFire',
                               'ts','hfss','hfls','rsus','rsds','rlds',
                               'albedo',
                               'clt','rldscs',
                               'prtas', 'rldsdiff'],
                     'name':['$\Delta$Near-Surface Temperature',
                             '$\Delta$Precipitation',
                             '$\Delta$GPP',
                             '$\Delta$Total Land Carbon',
                             '$\Delta$Vegetation Carbon',
                             '$\Delta$Soil Carbon',
                             '$\Delta$Litter Carbon',
                             '$\Delta$Soil Carbon (fast)',
                             '$\Delta$Soil Carbon (slow)',
                             '$\Delta$Soil Carbon (medium)',
                             '$\Delta$Evapotranspiration',
                             '$\Delta$NPP',
                             '$\Delta$Het. respiration',
                             '$\Delta$NEP',
                             '$\Delta$Fire Emissions',
                             '$\Delta$Surface Temperature',
                             '$\Delta$Sensible Heat Flux',
                             '$\Delta$Latent Heat Flux',
                             '$\Delta$Outgoing Shortwave Radiation',
                             '$\Delta$Incoming Shortwave Radation',
                             '$\Delta$Incoming Longwave Radiation',
                             '$\Delta$Albedo',
                             '$\Delta$Cloud Cover Fraction',
                             '$\Delta$Incoming Longwave Radation (clear sky)',
                             '$\Delta$Pr/$\Delta$Tas',
                             '$\Delta$Longwave - $\Delta$Longwave clear sky'] ,
                     'name_short': ['$\Delta$Tas',
                             '$\Delta$Pr',
                             '$\Delta$GPP',
                             '$\Delta$cLand',
                             '$\Delta$cVeg',
                             '$\Delta$cSoil',
                             '$\Delta$cLitter',
                             '$\Delta$cSoil (fast)',
                             '$\Delta$cSoil (slow)',
                             '$\Delta$cSoil (medium)',
                             '$\Delta$ET',
                             '$\Delta$NPP',
                             '$\Delta$rh',
                             '$\Delta$NEP',
                             '$\Delta$fFire',
                             '$\Delta$T$_s$',
                             '$\Delta$Q$_S$',
                             '$\Delta$Q$_H$',
                             '$\Delta$SW$_U$',
                             '$\Delta$SW$_D$',
                             '$\Delta$LW$_D$',
                             '$\Delta$Albedo',
                             '$\Delta$CLT',
                             '$\Delta$LW$_D$ clear sky',
                             '$\Delta$PrTas',
                             '$\Delta$rlds - $\Delta$rldscs'] ,
                     'unit': ['$^\circ$C',
                              'mm '+timstat+'$^{-1}$',
                              'kg m$^{-2}$'+timstat+'$^{-1}$',
                              'kg m$^{-2}$','kg m$^{-2}$','kg m$^{-2}$','kg m$^{-2}$',
                              'kg m$^{-2}$','kg m$^{-2}$','kg m$^{-2}$',
                              'mm '+timstat+'$^{-1}$',
                              'kg m$^{-2}$ '+timstat+'$^{-1}$',
                              'kg m$^{-2}$ '+timstat+'$^{-1}$',
                              'kg m$^{-2}$ '+timstat+'$^{-1}$',
                              'kg m$^{-2}$ '+timstat+'$^{-1}$',
                              '$^\circ$C','W m$^{-2}$','W m$^2{-2}$',
                              'W m$^{-2}$','W m$^{-2}$','W m$^{-2}$',
                              '%',
                              '%','W m$^{-2}$',
                              'mm/degC',
                              'W m$^{-2}$'],
                     'rm':[30,30,10,10,10,10,10,10,10,10,
                           30,10,10,10,10,
                           30,30,30,30,30,30,
                           30,30,30,
                           30,30],
                    'minmax':[2.5,500,1.0,20.0,
                              15,5,2,0.6,0.6,0.6,
                              400,0.5,0.5,0.5,0.25,
                              2.5,50,50,
                              30,30,10,
                              20, 5, 10,2,10],
                    'minmax_scaled':[8.0,500,1.0,50.00,
                                     20,10,5,0.6,0.6,0.6,
                                     400,0.5,0.5,0.25,0.25,
                                     2.5,100,100,
                                     30,30,30,50,
                                     30, 100,20,100]\
                               }).set_index('var')   
    
    


        
#%% ALL in one plot


scaled = False  ## e.g. dTas per frac or dTas per 10**3km2 

if scaled == True:
    tag = '_scaleDF'
    by = 'area' ## frac or area
else:
    tag = ''

if scaled == False:       
    variables = ['tas','ts','pr','cLand','cVeg',
                 'cSoil','cSoilSlow','cSoilMedium','cSoilFast',
                 'cLitter',
                 'evspsbl',
                 'gpp','npp','rh','nep','fFire','hfss','hfls',
                 'rsus','rsds','rlds','albedo','clt','rldscs',
                 'rldsdiff']  
elif scaled == True:
    variables = ['tas','cLand'] #,'cVeg','cSoil', ]
 
rr = 0
timstat = 'year'
typ = '_'

if type(variables) == str:
    length = 1
    var = [variables]
elif type(variables) == list:
    length = np.shape(variables)[0]
    var = variables        

for vv in [1]:#range(0,len(variables)):
        
    if scaled == False:
        var_min = -varinfo.loc[var[vv]]['minmax']
        var_max = varinfo.loc[var[vv]]['minmax']
    else:
        var_min = -varinfo.loc[var[vv]]['minmax_scaled']
        var_max = varinfo.loc[var[vv]]['minmax_scaled'] 
        
        if var[vv] == 'tas':
            var_min = -2.0
            var_max = 2.0
        elif var[vv] == 'cLand':
            var_min = -20.0
            var_max = 20.0
        elif var[vv] == 'rldsdiff':
            var_min = -5.0
            var_max = 5.0            
        
    ## --------------------------------------
    fig_scale = 2
    fig = plt.figure(figsize=(4*fig_scale,3*fig_scale))
    gs1 = plt.GridSpec(4, 3, height_ratios=[1, 1, 1, 0.05])
    
    gs1.update(wspace=0.05, hspace=0.025) 
  
    i = 0; j = 0; m = 0

    for model in models:#['MPI']:#
        print 'i = ' + str(i) + ' j = ' + str(j)

        if model == 'CESM2' and var[vv] in ['rldscs','rldsdiff']:
            m = m + 1
            i = 0
            j = j + 1
            continue
        if model == 'CNRM' and var[vv] in ['fFire']:
            continue
        if model == 'IPSL' and var[vv] in ['fFire']:
            m = m + 1
            i = i + 1
            continue  
        if model == 'MIROC' and var[vv] in ['fFire']:
            continue          
        if model == 'EC' and var[vv] in ['cSoilSlow','cSoilFast','cSoilMedium']:
            continue                 
        if model == 'Can' and var[vv] in ['cSoilSlow','cSoilFast','fFire',\
                                 'cLand','cLitter','cSoil']:
            m = m + 1
            i = i + 1
            continue            
        if model == 'BCC' and var[vv] in ['cSoilSlow','cSoilFast','cSoilMedium',
                                 'cLand','cLitter','cSoil',
                                 'fFire',]:
            m = m + 1
            i = 0
            j = j + 1            
            continue    
        if model == 'UKESM' and var[vv] in ['cSoilSlow','cLitter','fFire']:
            continue  
#        if model == 'MPI' and var[vv] in ['clt','rldscs','rldsdiff']:
#            m = m + 1
#            i = i + 1
#            continue
        
        #### created with time series scripts (or ToE_ts)
        if mistral == True:
            savepath = "/Users/lenaboysen/mistral/LUMIP/" 
            path="/Users/lenaboysen/mistral/LUMIP/"+model+"/"
        else:
            savepath = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"
            path = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"+model+"/"
        
        if var[vv] == 'prtas':
            file_out1 = savepath + 'tas' + '_' + model +'_map.obj'
            file_out2 = savepath + 'pr' + '_' + model +'_map.obj'
            if os.path.isfile(file_out1):
                ds1a = pickle.load(open(file_out1,'rb')) 
                ds1 = ds1a['var_masked']#/ds1a[model+'_CTL_tas']
                
                ds2a = pickle.load(open(file_out2,'rb'))
                ds2 = ds2a['var_masked']/ds2a[model+'_CTL_pr']
                ds = ds2/ds1
        elif var[vv] == 'rldsdiff':
            file_out1 = savepath + 'rlds' + '_' + model +'_map.obj'
            file_out2 = savepath + 'rldscs' + '_' + model +'_map.obj'
            if os.path.isfile(file_out1):
                ds1a = pickle.load(open(file_out1,'rb')) 
                ds1 = ds1a['var_masked']
                
                ds2a = pickle.load(open(file_out2,'rb'))
                ds2 = ds2a['var_masked']
                ds = ds1 - ds2
                ds = ds.to_dataset()
                ds = xr.merge([ds,ds2a['def_mask']])
        else:
            file_out = savepath + var[vv] + '_' + model +'_map.obj'
            if os.path.isfile(file_out):
                ds = pickle.load(open(file_out,'rb'))
                
#        plt.pcolormesh(ds1)
#        plt.colorbar()
#        plt.show()            
            
        def_file = savepath + 'def_mask_regions.obj'
        if os.path.isfile(def_file):
            print 'loading def mask for ' + model
            def_mask_regions = pickle.load(open(def_file,'rb'))
            def_mask = def_mask_regions[model][model+'_defmask_glob']
            deffrac = def_mask_regions[model][model+'_deffrac_glob']*(-1)/100.
            deffrac = deffrac.where(deffrac > 0, 0)
            cellarea = def_mask_regions[model][model+'_cellarea']
            
            deffrac = deffrac.where(deffrac > 0.1, 0)
#        
#            for ff in np.arange(0.1,1.0,0.1):
#                deffrac = deffrac.where((deffrac <= (ff-0.1)) | (deffrac > ff),ff*100)
#            deffrac = deffrac/100.
            
#            deffrac = deffrac.where(deffrac > 0.01, 0)
            defarea = deffrac*cellarea/10**9 ##10**3 km2 ## m2 to km2 = /10**6 
#            defarea = defarea.where(deffrac > 0.0, 0)
#        
#            plt.pcolormesh(defarea)
#            plt.colorbar()
#            plt.show()              
#                
        lon = ds.lon
        lat = ds.lat 
        
        lons = whitelinefix(lon)
        lons, lats = np.meshgrid(lons, lat)
        
        cmap, tcks, norm = create_colorbar(var_min,var_max)
           
        axes = plt.subplot(gs1[j,i], projection=ccrs.Robinson(central_longitude=0.0))
        
        if scaled == True:
            if by == 'area':
                ds_plot = ds['var_masked'] / defarea
            else: 
                ds_plot = ds['var_masked'] / deffrac #defarea
        else:
            ds_plot = ds['var_masked']
#            
#            if model in ['EC', 'Can']:
#                ds_plot = ds_plot.where((ds_plot == 0.0))
        
#        plt.pcolormesh(ds['var_masked']/ defarea)
#        plt.colorbar()
#        plt.show()  
        
        dummy = ds_plot.fillna(0).values
        print '*** '+ var[vv] + ' Min: '+model  + str(round(dummy[np.isfinite(dummy)].min(),2))
        print '*** '+ var[vv] + ' Max: '+model  + str(round(dummy[np.isfinite(dummy)].max(),2))     
        
                    
        dd = ds_plot.values
        dd = dd[np.isfinite(dd)]
       
        print '*** '+ var[vv] + ' Mean: '+model  + str(round( np.nanmean(dd[~np.isnan(dd)]),2))
        
        plot = ds_plot.T.plot.pcolormesh(transform = ccrs.PlateCarree(), 
                                      cmap = cmap, # norm = norm, 
                                      vmin = var_min, vmax = var_max, 
                                      ax=axes, add_colorbar=False)
        
#        plt.pcolormesh(ds_plot)
#        plt.colorbar()
#        plt.show()  
        
        axes.coastlines(color='grey',linewidth=0.5)
        axes.outline_patch.set_linewidth(0.25)
        axes.set_title(varinfo.loc[var[vv]]['name']+' ['+varinfo.loc[var[vv]]['unit']+']',fontsize=14)
        axes.gridlines(color='grey',linewidth=0.5, alpha=0.5, linestyle='--')
      
    
        cp = ds['def_mask'].T.plot.contour(ax=axes, levels=1, transform = ccrs.PlateCarree(),
          add_colorbar=False,vmin = 0, vmax = 1.1,colors='k', origin="lower" ,linewidths=0.5)
    
        axes.text(0.5,1.07,
            list(models_name[model])[0],
            color='slategrey',
            horizontalalignment='center',
            verticalalignment='center',
            transform=axes.transAxes,
            fontsize=cexx) #,
        #    bbox={'facecolor':'white', 'alpha':0.7, 'pad':5})
        
        axes.text(0.1,1.07,
            ['(a)','(b)','(c)','(d)','(e)','(f)','(g)','(h)','(i)'][m],
            color='black',
            horizontalalignment='center',
            verticalalignment='center',
            transform=axes.transAxes,
            fontsize=cexx) #,        
        
        i = i + 1
        
        if m in [2,5,8]:
            i = 0
            j = j + 1
        
        m = m + 1
            

    ### --- Colorbar ----
    axes = plt.subplot(gs1[3, :])
    axes.set_visible(False)
#    cbar_ax = fig.add_axes([0.12, 0.1, 0.8, 0.03]) ## x0, y0, width, height
    cbar_ax = fig.add_axes([0.22, 0.1, 0.6, 0.02]) ## x0, y0, width, height 
    bar = plt.colorbar(plot, cax=cbar_ax, 
                       ticks=tcks, boundaries=tcks,
                       orientation='horizontal',extend='both')
    
#    labels = bar.ax.xaxis.get_ticklabels()
#    labelsneg = np.take(labels,range(0,(len(labels)/2)))
##    
##    lableszero = np.take(labels, range((len(labels)/2)-2,(len(labels)/2)+1))
##    
#    labelspos = np.take(labels,range(len(labels)/2+1,len(labels)))
##    
#    for label in labelsneg[::2]:
#        label.set_visible(False)
#        
#    for label in labelspos[::2]:
#        label.set_visible(False)
#        
    for label in bar.ax.xaxis.get_ticklabels()[::2]:
            label.set_visible(False)
        
    
    bar.ax.tick_params(labelsize=10,length=2, width=1)
    bar.outline.set_visible(False)
    
    if scaled == False:
        bar.set_label(varinfo.loc[var[vv]]['name'] + ' ['+varinfo.loc[var[vv]]['unit']+']',fontsize=14,labelpad=-40)
    else:
        
        if by == 'area':
            bar.set_label(varinfo.loc[var[vv]]['name_short'] + '/$\Delta$F ['+\
                      varinfo.loc[var[vv]]['unit']+' /10$^3$ km$^2$]',
                        fontsize=14,labelpad=-50) 
        else:
            bar.set_label(varinfo.loc[var[vv]]['name_short'] + ' $\Delta$F$^{-1}$ ['+\
                          varinfo.loc[var[vv]]['unit']+' frac$^{-1}$]',
                        fontsize=14,labelpad=-40)     
        
    import matplotlib.patches as mpatches
    
    p_fancy = mpatches.FancyBboxPatch((0.8, 0.1),
                                 abs(0.3), abs(0.5),
                                 boxstyle="round, pad=0.1",
                                 fc='white',
                                 ec='black',
                                 label = '$\Delta$F',
                                 linewidth = 0.5)
    plt.legend(handles=[p_fancy], fontsize=cexx-2,
                   bbox_to_anchor=(-0.15, 3.0), loc=2, borderaxespad=0.)
    # 0.02, 2.5
    
    plt.show()
    
    fig.tight_layout()   
    if scaled == True:             
        if by == 'area':
            pngfile='/Users/lenaboysen/Google Drive/LUMIP/Maps/'+var[vv]+'_scaled_ALL_area.png' 
        else:
            pngfile='/Users/lenaboysen/Google Drive/LUMIP/Maps/'+var[vv]+'_scaled_ALL.png' 
    else:
        pngfile='/Users/lenaboysen/Google Drive/LUMIP/Maps/'+var[vv]+'_ALL'+tag+'.png'
    fig.savefig(pngfile,dpi=300, bbox_inches='tight',width=400, height=300)
    plt.close()              
        #        

                