
#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 16 15:50:15 2018

@author: lenaboysen


Deforestation: Maps of significant changes in T etc. 

"""


import os
import numpy as np
np.set_printoptions(threshold=100) # 'nan'
import os.path
import sys as sys
import pickle

#import cdo
#cdo = cdo.Cdo()
#cdo.setCdo('/opt/local/bin/cdo')
import xarray as xr
#from matplotlib import gridspec
#from datetime import datetime, date


#plot
import matplotlib.pyplot as plt
#import matplotlib as mpl
#import matplotlib.colors as colors
import seaborn as sns; sns.set(color_codes=True)

#import plotly.plotly as py
#import plotly.graph_objs as go
import pandas as pd


new_path = '/Users/lenaboysen/Google Drive/python/'
if new_path not in sys.path:
    sys.path.append(new_path)
    
#from mod_tTest import *
import mod_tTest as ttest

 
#% Constants
kg_C_per_kg_CO2 = 0.272918
kg_C_perMol = 0.012011
C_to_K = 273.15
MPa_to_mm = 1022.8
#%% FUNCTIONS

def average_da(self, dim=None, weights=None):
#    self = DEF_reg #_IPSL
#    weights = weights #_IPSL
#    dim=['lon','lat']
#    
    if weights is None:
        return self.mean(dim)
    else:
        if not isinstance(weights, xr.DataArray):
            raise ValueError("weights must be a DataArray")

        # if NaNs are present, we need individual weights
        if self.notnull().any():
            total_weights = weights.where(self.notnull()).sum(dim=dim)
        else:
            total_weights = weights.sum(dim)

        average_da = (self * weights).sum(dim) / total_weights
        return average_da
    
#%%  DEFINE VARIABLES
mistral = False
regions = ['_glob','_soam','_africa','_sea_aust','_noam_temp','_noam_bor','_eura_bor','_eura_temp']
regions_names = ['Global','South America','Africa','SE Asia & Aust.','North Am. temp.','North Am. bor.','Eurasia bor.','Eurasia temp.']

models = ['MPI','IPSL','CESM2','Can','CNRM','BCC','MIROC','UKESM','EC']
models_name = pd.DataFrame({'IPSL': ['IPSL-CM6A-LR'],
                            'MPI': ['MPI-ESM-1.2.0'],
                             'CESM2': ['CESM2'],
                             'Can': ['CanESM5'],
                             'CNRM': ['CNRM-ESM2-1'],
                             'BCC': ['BCC-CSM2-MR'],
                             'MIROC': ['MIROC-ES2L'],
                             'UKESM':['UKESM1-0-LL'],
                             'EC':['EC-Earth3-Veg']})


timstat = 'year'

meta = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                              'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[151, 80,  80, 90, 80, 81,150, 80, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90,90,90, 90],
                     'nruns':[7,3, 3, 2, 1, 1, 1, 1, 1],
                     'runs': [['r1i1p1f1','r2i1p1f1','r3i1p1f1','r4i1p1f1',\
                               'r5i1p1f1','r6i1p1f1','r7i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p1f1','r2i1p1f1','r3i1p1f1'],\
                              ['r1i1p2f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f1'],\
                              ['r1i1p1f2'],\
                              ['r1i1p1f1']]\
                               }).set_index('model')
    
metaCTL = pd.DataFrame({'model':['MPI','IPSL','CESM2',\
                                 'Can','CNRM','BCC','MIROC','UKESM','EC'],
                     'imax':[151, 80,  80, 90, 80, 81, 90, 90, 80],
                     'imaxctl': [90, 90, 90, 90, 90, 90, 90, 90, 90],
                     'nruns':[ 7, 3, 1, 2, 1, 1, 1, 1, 1],
                     'runs': [['piControl'],
                              ['piControl'],
                              ['piControl'],\
                              ['piControl'],\
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl'],
                              ['piControl']]}).set_index('model')

## index = rownames; select with meta.loc['IPSL']    
cols = pd.DataFrame({'IPSL': ['orchid','purple'],
                             'CESM': ['orchid','orchid'],
                              'MPI': ['indianred','indianred'],
                              'CESM2':['dodgerblue','dodgerblue'],
                              'Can': ['orange','orange'],
                              'BCC': ['mediumblue','mediumblue'],
                              'CNRM' : ['seagreen','seagreen'],
                              'MIROC' : ['gray','gray'],
                              'UKESM': ['pink','pink'],
                              'EC':['turquoise','turquoise']})

### ---------------------------------------
'''
   Read data
'''
### ---------------------------------------

variables = ['tas','pr','cLand','cVeg','cSoil','cSoilSlow','cSoilFast','cLitter',
                'cSoilMedium','evspsbl',
                 'gpp','npp','rh','nep','fFire','NEPfFire','treeFrac',
                 'ts','hfss','hfls','rsus','rsds','rlds','clt','rldscs']

'''
tas = near surf temp = K
ts  = surf temp     = K
tws = surf temp water = K
tsl = soil temp = K

sfcWind = surf Wind = m/s
clt = total cloud fraction = %

pr = precip = mm/yr
et = total ET  = mm/yr
es = bare soil evap 
evspsbl = evap
tran = transpiration
mrro = total runoff
mrros = surface runoff
mrrb = drainage
sbl = surface ice/snow sublimation

mrso total soil moisture        = kg/m2
rzxc = root zone soil moisture

CO2_flux = total upward CO2 flux = kgC/m2yr
CO2_flx_ocean = upward ocean flx (acc)
fFire = C emissions to atm due to fire
fco2nat = C flux to atm from nat (wo LUC!)

netAtmosLandCO2Flux = between land and atm, positive to land from all processes

co2mass = kg/m2
'''
timstat = 'year'
timstr = timstat
types = ['','GD']


varinfo = pd.DataFrame({'var':['tas',
                               'pr',
                               'gpp',
                               'cLand',
                               'cVeg','cSoil','cLitter','cSoilFast','cSoilSlow','cSoilMedium',
                               'treeFrac',
                               'evspsbl',
                               'npp',
                               'fFire',
                               'rh',
                               'nep','NEPfFire',
                               'ts','hfss','hfls','rsus','rsds','rlds',
                               'clt','rldscs'],
                     'name':['$\Delta$Near-Surface Temperature',
                             '$\Delta$Precipitation',
                             '$\Delta$GPP',
                             '$\Delta$Total Land Carbon',
                             '$\Delta$Vegetation Carbon',
                             '$\Delta$Soil Carbon',
                             '$\Delta$Litter Carbon',
                             '$\Delta$Soil Carbon (fast)',
                             '$\Delta$Soil Carbon (slow)',
                             '$\Delta$Soil Carbon (medium)',
                             '$\Delta$Tree cover',
                             '$\Delta$Evapotranspiration',
                             '$\Delta$NPP',
                             '$\Delta$Fire emissions',
                             '$\Delta$Het. respiration',
                             '$\Delta$NEP',
                             '$\Delta$(NEP-fFire)',
                             '$\Delta$Surface Temperature',
                             '$\Delta$Sensible Heat Flux',
                             '$\Delta$Latent Heat Flux',
                             '$\Delta$Outgoing Shortwave Radiation',
                             '$\Delta$Incoming Shortwave Radation',
                             '$\Delta$Incoming Longwave Radiation',
                             '$\Delta$Cloud Cover Fraction',
                             '$\Delta$Incoming Longwave Radation (clear sky)'] ,
                     'name_short': ['$\Delta$Tas',
                             '$\Delta$Pr',
                             '$\Delta$GPP',
                             '$\Delta$cLand',
                             '$\Delta$cVeg',
                             '$\Delta$cSoil',
                             '$\Delta$cLitter',
                             '$\Delta$cSoil (fast)',
                             '$\Delta$cSoil (slow)',
                             '$\Delta$cSoil (medium)',
                             '$\Delta$Tree cover',
                             '$\Delta$ET',
                             '$\Delta$NPP',
                             '$\Delta$fFire',
                             '$\Delta$rh',
                             '$\Delta$NEP',
                             '$\Delta$(NEP-fFire)',
                             '$\Delta$T$_s$',
                             '$\Delta$Q$_S$',
                             '$\Delta$Q$_H$',
                             '$\Delta$SW$_U$',
                             '$\Delta$SW$_D$',
                             '$\Delta$LW$_D$',
                             '$\Delta$CLT',
                             '$\Delta$LW$_D$ clear sky'] ,
                     'unit': ['$^\circ$C',
                              'mm '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC','GtC','GtC','GtC','GtC','GtC','GtC',
                              'Mkm$^2$',
                              'mm '+timstat+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'GtC '+timstr+'$^{-1}$',
                              'K','W m$^{-2}$','W m$^{-2}$',
                              'W m$^{-2}$','W m$^{-2}$','W m$^{-2}$',
                              '%','W m$^{-2}$'],
                     'rw':[30,30,10,10,10,10,10,10,10,10,1,30,10,10,10,10,10,
                           30,30,30,30,30,30,30,30],
                     'majorticks': [[-0.7, 0.6, 0.1],\
                                    [-250, 100, 50],\
                                    [-8, 4, 2],\
                                    [-300, 100, 50],\
                                    [-300, 100, 50],\
                                    [-15, 15, 5],\
                                    [-55, 15, 10],\
                                    [-15, 15, 5],\
                                    [-40, 15, 10],\
                                    [-180, 50, 25],\
                                    [-200,50,25],
                                    [-150,50,25],
                                    [-8, 4, 2],
                                    [10, 10, 5],
                                    [10, 10, 5],
                                    [10, 10, 5],
                                    [-0.7, 0.6, 0.1],
                                    [-0.7, 0.6, 0.1],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],
                                    [-100,100,25],]\
                               }).set_index('var')

#%%       PLOT            
import matplotlib.gridspec as gridspec


linestyles = ['-', '-.', '--', ':']
lwd = [3, 1.5, 1.5, 1.5]

cexx=10
cexx2=12
for rr in [0]:#range(0,8):   

    fig_scale = 2
    fig = plt.figure(figsize=(4*fig_scale,3*fig_scale))
    
    gs1 = plt.GridSpec(2,3, height_ratios=[1,1],width_ratios=[1,1,1])
#    gs1.update(wspace=0.4, hspace=0.1)  
    gs1.update(wspace=0.5, hspace=0.2) 
    
    i = 0; j = 0; p = 0    
    
    for var in ['treeFrac','treeFrac']: #,'gpp','cLand','cVeg','cLitter','cSoil']:
    
        ax = plt.subplot(gs1[j,i])
   
        plt.axhline(y=0, color='k', linestyle='-',linewidth= 1)   
        
        sns.set_context("notebook", font_scale=1.2, rc={"lines.linewidth": 1.2})
        sns.set_style("whitegrid")
        custom_style = {
                'grid.color': '0.8',
                'grid.linestyle': '--',
                'grid.linewidth': 0.5,
                }
        sns.set_style(custom_style)  
    
#        ax.set_ylim(varinfo.loc[var]['majorticks'][0],varinfo.loc[var]['majorticks'][len(varinfo.loc[var]['majorticks'])-1])
    
        types = ['','GD']
        multi = None
        for model in models:
            print model
                  
            
            if mistral == True:
                savepath = "/Users/lenaboysen/mistral/LUMIP/"  
                path="/Users/lenaboysen/mistral/LUMIP/"+model+"/"
            else:
                savepath = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"
                path = "/Users/lenaboysen/Documents/Crescendo_LUMIP/LUMIP/DATA/"+model+"/"
      
        
            file_out = savepath + 'def_mask_regions.obj'
            if os.path.isfile(file_out):
                def_mask_regions = pickle.load(open(file_out,'rb'))
                
            ca = def_mask_regions[model][model+'_cellarea']
            reg = def_mask_regions[model][model+regions[rr]]
            init = def_mask_regions[model][model+'_init_forest']
            dim = ['lat','lon']
            
            init_forest_area = (init/100*ca).sum(dim)/1e12
            
            print 'initial forest '+ str(init_forest_area)

#            print 'LOAD TS ' +  model
            file_out = path + 'TS_'+model+'_'+var+'.obj'
            if os.path.isfile(file_out):
                Diff_out = pickle.load(open(file_out,'rb'))
                
            
            for tt in [0, 1]: 
                ## build envelope from ensmembers
                itemsR = [s for s in Diff_out.keys() if regions[rr]+'_' in s]   
                itemsM = [s for s in itemsR if model in s]
                itemsGD = [s for s in itemsM if var+types[tt]+'_' in s]
            
                if len(meta.loc[model]['runs']) > 1:
#                    X = pd.date_range(str(1850)+'-01-01', periods=151, freq='Y')
                    
                    
                    X = pd.date_range(str(1850)+'-01-01', 
                                      periods=meta.loc[model]['imax'], 
                                      freq='Y')
                    
                    rw = varinfo.loc[var]['rw']
                    if var == 'treeFrac':
                        rw = 1
                    Diffmin = Diff_out[itemsGD].rolling(\
                                time = rw, center=True).mean().to_array().min(axis=0)
                    Diffmax = Diff_out[itemsGD].rolling(\
                                time = rw, center=True).mean().to_array().max(axis=0)
                    if i == 0:
                        plt.fill_between(X, Diffmax, Diffmin, 
                                         color=cols[model][tt],
                                         linewidth=0.,
                                         facecolor=cols[model][tt],
                                         alpha=[0.2,0.4][tt])
                    else:
                        plt.fill_between(X, 
                                         init_forest_area+Diffmax, 
                                         init_forest_area+Diffmin, 
                                         color=cols[model][tt],
                                         linewidth=0.,
                                         facecolor=cols[model][tt],
                                         alpha=[0.2,0.4][tt])                       
                    
                ### data (=ensmean) is already with runmean
                if tt == 1:    #+ '_' + types[tt],\
                    if i == 0:
                        Diff_out2 = Diff_out[model + '_' + var + types[tt] + regions[rr]]
                    else:
                        Diff_out2 = init_forest_area + Diff_out[model + '_' + var + types[tt] + regions[rr]]
                    
                    Diff_out2.plot(\
                            label=list(models_name[model])[0],\
                            ax=ax, color=cols[model][1],alpha=1,
                            linestyle=[':','-'][tt],
                            linewidth=[3,2][tt])                  
                else:
                    if i == 0:
                        Diff_out2 = Diff_out[model + '_' + var + types[tt] + regions[rr]]
                    else:
                        Diff_out2 = init_forest_area + Diff_out[model + '_' + var + types[tt] + regions[rr]]
                    
                    Diff_out2.plot(\
                            ax=ax, color=cols[model][1],alpha=1,
                            linestyle=[':','-'][tt],
                            linewidth=[3,2][tt])     
                    
                ### ==== prepare multimodel mean ====
                if i == 0 and tt == 1:
                    if multi is None:
                        multi = Diff_out[model + '_' + var + types[tt] + regions[rr]].to_dataframe()
                    else:
                        multim = Diff_out[model + '_' + var + types[tt] + regions[rr]].to_dataframe()
                        multi = pd.concat([multi, multim], axis=1)
                        del(multim)
                        
                    if model == 'EC':
                        multimean = multi.mean(axis=1)[0:66]
                        multisd = multi.std(axis=1)[0:66]
                        X = pd.date_range(str(1850)+'-01-01', 
                                          periods=66, 
                                          freq='Y')
                        plt.fill_between(X, 
                                         (multimean-multisd), 
                                         (multimean+multisd), 
                                         color='grey',
                                         linewidth=0.,
                                         facecolor=cols[model][tt],
                                         alpha=[0.2,0.2][tt])
                        ax.plot(X,
                                multimean,
                                label='multi-model mean',\
                                color='black',alpha=1,
                                linestyle=[':','-'][tt],
                                linewidth=[2,2][tt])                  
                
            
        ax.autoscale()       
        ax.set_xlim(xmin=pd.Timestamp(str(1850)+'-01-01'), 
                    xmax=pd.Timestamp(str(1930)+'-12-31')) 
 
        ax.tick_params(axis='x', labelsize=cexx)  
        xticks = pd.date_range(start=str(1850)+'-12-31', end=str(1930)+'-12-31', freq='20Y')
        ax.set_xticks(xticks.to_pydatetime(), minor=True)
        ax.set_xticklabels(np.arange(0,100,20),fontsize = cexx)

        plt.xticks(xticks)
        
        ax.set_ylabel(varinfo.loc[var]['name_short']+' ['+varinfo.loc[var]['unit']+']',fontsize=cexx2) 
        plt.yticks(fontsize=cexx, rotation=0) 

        if not p in [0,1]:
            ax.set_ylabel('',fontsize=cexx2)  
        else:
            ax.set_xlabel('Time (years)',fontsize=cexx)
        
        handles, labels = ax.get_legend_handles_labels()
        
        
        import matplotlib.lines as mlines
        if p == 0:
            x, y = np.array([[2.3,2.3], [0.9,0.9]])
            line = mlines.Line2D(x , y , 
                                 lw=2, linestyle=':', 
                                 alpha=1, color='black',
                                 label = 'global',
                                 transform=ax.transAxes)
            
            x, y = np.array([[2.3,2.1], [0.9,0.9]])
            line2 = mlines.Line2D(x , y , 
                                 lw=2, linestyle='-', 
                                 alpha=1,color='black',
                                 label = 'over $\Delta$F',
                                 transform=ax.transAxes)
            
            plt.legend(handles=[line,line2], ncol=1, loc='center left',
                                     fontsize=cexx-2,
                       bbox_to_anchor=(0.1, 1.2), borderaxespad=0.)
#                       bbox_to_anchor=(-0.0, 1.2), borderaxespad=0.)

        ##-------------------------------------------
        # legend in empty plot
        if i==1 and j==0:
            
            ax = plt.subplot(gs1[j,i])
            
    #        indices = np.arange(0,6,1) 
            leg = ax.legend(handles,
                          labels,
                          ncol=3,
                          fontsize=cexx-2,
                          prop={'size':8},
                          title='',
                          loc='center left', 
                          bbox_to_anchor=(-0.5, 1.2), borderaxespad=0)
#                          bbox_to_anchor=(-0.8, 1.2), borderaxespad=0)
            
            for line in leg.get_lines():
                line.set_linewidth(2.0)    
        
        ax.text(-0.2,1,['(a)','(b)','(c)','(d)'][i],
                    color='k',
                    horizontalalignment='left',
                    verticalalignment='center',
                    transform=ax.transAxes,
                    fontsize=cexx,
                    bbox={'facecolor':'white', 'alpha':0.7, 'pad':5})   
                
        i = i + 1
 


       
    ###  Zonal deforestation

    ax = plt.subplot(gs1[0,2])
    plt.axhline(y=0, color='k', linestyle='-',linewidth= 1)   
    
    sns.set_context("notebook", font_scale=1.2, rc={"lines.linewidth": 1.2})
    sns.set_style("whitegrid")
    custom_style = {
            'grid.color': '0.8',
            'grid.linestyle': '--',
            'grid.linewidth': 0.5,
            }
    sns.set_style(custom_style)  
    ax.set_ylim(-90, 90)
    xticks = np.arange(-0.6,0,0.1)
    ax.set_xlim(-0.5, 0.02)    
    
    for model in models:
        def_file = savepath + model + '_def_mask_regions.nc'
        if os.path.isfile(def_file):
            deffrac = xr.open_dataset(def_file,
                                 cache=False, 
                                 decode_times=False)
            deffrac.close()
            deffrac = deffrac.where(deffrac < 0, 0)
            deffrac = deffrac[model +'_deffrac_glob']/100.*(-1)
            
        ca_file = savepath + model + '_cellarea.nc'
        if os.path.isfile(ca_file):                
            cellarea = xr.open_dataset(ca_file,
                                 cache=False, 
                                 decode_times=False)
            cellarea.close()
            cellarea = cellarea[model + '_cellarea']

#        plt.pcolormesh(cellarea) #ds_GD['var_masked'])
#        plt.colorbar()
#        plt.show() 

        
        lat = deffrac.lat
        latdiff = np.append(np.diff(lat),np.diff(lat)[0])
        
        rw_base = 10.
        ### get value for every latitude
        latdiffx = round(latdiff.mean(),1)            
        if (latdiffx > rw_base ):
            rw =  1
        else:
            rw = int(rw_base/latdiffx)
#        print 'rw = ' + str(rw) 
#        print 'rw*latdiff = ' + str(rw*latdiffx)                
                
        defarea = deffrac.where(deffrac > 0.1, 0) * cellarea / 10**12
  
        weights = cellarea.copy(deep=True)/np.sum(cellarea)
        weights = cellarea.sum('lon') / cellarea.sum(['lon','lat'])

        defarea_sum = defarea.sum(['lon'])/latdiff*(-1)
        print model + ' dF = '+str(round(defarea.sum(),2)) + ' Mkm2'
        
        plt.plot(defarea_sum.rolling(lat = rw, center=True).mean(), 
                 lat,color=cols[model][0],\
                 linestyle='-', linewidth=1,alpha=1 )        
        
    yticks = np.arange(-90,90,20) 
    ax.set_yticks(yticks, minor=False)                
    plt.yticks(fontsize=cexx) 
    ax.set_yticklabels(['']*len(yticks))
    
    ax.set_xticks(xticks, minor=False) 
    plt.xticks(fontsize=cexx)
    ax.tick_params(axis='x', labelsize=cexx)
    ax.set_xlabel('$\Delta$F [Mkm$^2$ lat$^{-1}$]',fontsize=cexx)
    ax.set_ylabel('Latitude',fontsize=cexx)    
    
    
#    for index, label in enumerate(ax.yaxis.get_ticklabels()):
#        if index % 2 != 0: # show only every 5th label
#            label.set_visible(False)
            
    for label in ax.xaxis.get_ticklabels()[::2]:
        label.set_visible(False)        
    
    label.set_visible(False)    
    ax.text(0,1,'c)',
            color='k',
            horizontalalignment='left',
            verticalalignment='center',
            transform=ax.transAxes,
            fontsize=cexx,
            bbox={'facecolor':'white', 'alpha':0.7, 'pad':5}) 
        
                
        
        
        

        
        
    plt.subplots_adjust(left=0.11, right=0.95, top=0.8, bottom=0.1)
    fig.show()  

    
    #SAVE THE PLOT 
    fig.tight_layout()
    pngfile='/Users/lenaboysen/Google Drive/LUMIP/Time_series/TreeFrac'+\
                                    regions[rr]+'_ALL.png' 
    fig.savefig(pngfile,dpi=300, bbox_inches='tight',width=400, height=300)
    plt.close()
        
    