#!/bin/bash
set -vex

model=MPI

base="/work/mj0060/m300178/LUMIP/"
#base="/scratch/local1/m300178/LUMIP/"
out_dir="${base}analysis/${model}"

#constants
kg_C_per_kg_CO2=0.272918
g_C_perMol=12.011
kg_C_perMol=0.012011
C_to_K=-273.15
missingValue=-99999


vars=( clt ) #pr hfls ta zg ts rlds rlus rsds rsus rlut rsut rsdt ) #clt rldscs hur ua uas va vas hus wap ps )


for xx in 1 #1 2 3 4 5 6 7 8
do
rr=r${xx}i1p1f1
if [ $xx -eq 1 ]; then
in_dir="/work/mh0469/m220053/mpiesm-1.2.01-release/experiments/deforest-globe_r1i1p1f1-LR/archive/CMIP6/LUMIP/MPI-M/MPI-ESM1-2-LR/deforest-globe/r1i1p1f1/Amon/"
elif [ $xx -eq 8 ]; then
rr=r1i1p2f1
in_dir="/work/mj0060/m300766/mpiesm-1.2.01-release/experiments/deforest-globe_r1i1p2f1-LR/archive/CMIP6/LUMIP/MPI-M/MPI-ESM1-2-LR/deforest-globe/r1i1p2f1/Amon/"
else
in_dir="/work/mj0060/m300766/mpiesm-1.2.01-release/experiments/deforest-globe_${rr}-LR/archive/CMIP6/LUMIP/MPI-M/MPI-ESM1-2-LR/deforest-globe/${rr}/Amon/"
fi



for vv in ${vars[@]}
do

f=($(ls ${in_dir}/${vv}/gn/v20190815/${vv}_Amon_MPI-ESM1-2-LR_deforest-globe_${rr}_gn_*))
if [ $xx != 8 ]; then
fout=${base}/${model}/${rr}/${vv}_Amon_MPI-ESM1-2-LR_deforest-globe_${rr}_gn_185001-200012.nc
else
fout=${base}/${model}/piControl/${vv}_Amon_MPI-ESM1-2-LR_deforest-globe_piControl_gn_185001-200012.nc
fi


if [ -f ${fout} ]; then 
        continue
else
	cdo mergetime ${f[@]} ${fout}
fi

done # vv

done # rr

exit
